﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Collections.Generic
Imports Microsoft.VisualBasic
Imports AspDotNetStorefrontCore
Imports System.Diagnostics
Imports System.Xml

Public Class wCustomApp
    Inherits XSLTExtensionBase

    Private Shared m_ProductHT As New Hashtable()
    Private Shared m_EntityHT As New Hashtable()
    Private Shared m_EntityBC As New Hashtable()

    Private m_ShowDebug As Boolean = True
    'SWANKREMOVE
    'Private m_ProductImagePath As String = "D:\webroot\cw3_cleanitsupply\web\images\product\" 'Physical location of product images
    'Private m_DowloadPath As String = "D:\webroot\cw3_cleanitsupply\web\download\" 'Physical location of download
    'ENDSWANKREMOVE
    'SWANKADD - Added New Key to Web.Config "SiteRootDirectory" for dynamic root depending on environment
    Private m_ProductImagePath As String = CommonLogic.Application("SiteRootDirectory") + "\images\product\" 'Physical location of product images
    Private m_DowloadPath As String = CommonLogic.Application("SiteRootDirectory") + "\download\" 'Physical location of download
    'ENDSWANKADD
    Private m_ProductImageUrl As String = "/images/product/" 'Base url for product images
    Private m_CsePricingProgram As String = "cs7pp" 'PriceProgram cookie value for cse pricing
    Private m_CseCustomerLevelID As Integer = 115 'PriceProgram customer level id

    Public Sub New()
        Me.New(Nothing, 1, Nothing)
    End Sub

    Public Sub New(ByVal cust As Customer, ByVal SkinID As Integer, ByVal EntityHelpers As Dictionary(Of String, EntityHelper))
        MyBase.New(cust, SkinID)
    End Sub


    'Home functions
    Public Function wGetSpecials(ByVal CategoryID As Integer, ByVal ProductCount As Integer) As String
        Dim Result As String = String.Empty

        Try
            Dim Qry As String = String.Empty

            Qry += " SELECT TOP " & ProductCount.ToString & " "
            Qry += "   p.ProductID, "
            Qry += "   pv.VariantID, "
            Qry += "   p.Name, "
            Qry += "   p.SEName, "
            Qry += "   p.ImageFilenameOverride, "
            Qry += "   pv.SkuSuffix, "
            Qry += "   ISNULL(pv.Price,0) AS Price, "
            Qry += "   ISNULL(pv.SalePrice,0) AS SalePrice,"
            Qry += "   ISNULL(ep.Price,0) AS ExtendedPrice"
            Qry += " FROM Product p "
            Qry += "   INNER JOIN ProductCategory pc ON p.ProductID = pc.ProductID "
            Qry += "   INNER JOIN ProductVariant pv ON p.ProductID = pv.ProductID "
            Qry += "   INNER JOIN ProductManufacturer pm ON p.ProductID = pm.ProductID "
            Qry += "   LEFT OUTER JOIN ExtendedPrice ep ON pv.VariantID = ep.VariantID AND ep.CustomerLevelID = " & wGetCustomerLevelID().ToString & " "
            Qry += " WHERE pc.CategoryID=" & CategoryID.ToString & " "
            Qry += "   AND p.Published=1 "
            Qry += "   AND p.Deleted=0 "
            Qry += "   AND pv.Published=1 "
            Qry += "   AND pv.Deleted=0 "
            Qry += "   AND p.ShowBuyButton=1 "
            Qry += " ORDER BY pc.DisplayOrder "

            Dim dt As DataTable = wGetDt(Qry)

            If dt.Rows.Count > 0 Then
                Dim PrdCnt As Integer = 1
                Dim sb As New StringBuilder()

                Dim ProductID As Integer = 0
                Dim VariantID As Integer = 0
                Dim Name As String = String.Empty
                Dim SEName As String = String.Empty
                Dim SkuSuffix As String = String.Empty
                Dim ImageFileNameOverride As String = String.Empty
                Dim Price As Decimal = Decimal.Zero
                Dim SalePrice As Decimal = Decimal.Zero
                Dim ExtendedPrice As Decimal = Decimal.Zero

                For Each dr As DataRow In dt.Rows
                    If PrdCnt = 5 Then
                        sb.Append(" </tr>" & vbCrLf)
                        sb.Append(" <tr>" & vbCrLf)
                        PrdCnt = 1
                    End If

                    ProductID = wGetInt(dr("ProductID"))
                    VariantID = wGetInt(dr("VariantID"))
                    Name = wGetStr(dr("Name"))
                    SEName = wGetStr(dr("SEName"))
                    SkuSuffix = wGetStr(dr("SkuSuffix"))
                    ImageFileNameOverride = wGetStr(dr("ImageFileNameOverride"))
                    Price = wGetDec(dr("Price"))
                    SalePrice = wGetDec(dr("SalePrice"))
                    ExtendedPrice = wGetDec(dr("ExtendedPrice"))

                    sb.Append(" <td>")
                    sb.Append("     <a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """>" & wLookupProductImage(ProductID, ImageFileNameOverride, SkuSuffix, Name, "special") & "</a><br/>")
                    sb.Append("     <a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """>" & Name & "</a>")
                    sb.Append("     <span class=""price_red"">" & FormatCurrency(wDetermineLevelPrice(VariantID, wGetCustomerLevelID(), Price, SalePrice, ExtendedPrice)) & "</span>" & vbCrLf)
                    sb.Append(" </td>" & vbCrLf)

                    PrdCnt += 1
                Next

                If sb.Length > 0 Then
                    For i As Integer = PrdCnt To 4
                        sb.Append("<td></td>")
                    Next
                    sb.Append("<tr>" & vbCrLf)

                    Result += "" & vbCrLf
                    Result += " <div id=""home-specials"">" & vbCrLf
                    Result += "<!-- .gray-bar -->" & vbCrLf
                    Result += "<table class=""table-base"" border=""0"">" & vbCrLf
                    Result += "<tr>" & vbCrLf & sb.ToString & vbCrLf & "</tr>" & vbCrLf
                    Result += "</table>" & vbCrLf
                    Result += "<div class=""more-link""><a href=""/c-348-this-months-specials.aspx""><strong>Shop All Cleaning Product Specials ...</strong></a></div><!--.more-link -->" & vbCrLf
                    Result += "</div><!--#home-specials -->"
                End If

                sb.Length = 0
                sb = Nothing
            End If

        Catch ex As Exception
            wPostError(ex.ToString, "wGetSpecials", "app")
        End Try

        Return Result
    End Function


    'Entity functions
    Public Function wGetEntityContent(ByVal TgtID As Integer, ByVal TgtType As String, ByVal Loc As String) As String
        Dim Result As String = String.Empty

        Try
            Dim Summary As String = String.Empty
            Dim Description As String = String.Empty

            Dim Qry As String = String.Empty

            Select Case LCase(TgtType)
                Case "manufacturer"
                    Qry += " SELECT Description, Summary FROM Manufacturer WHERE ManufacturerID=" & TgtID.ToString & " AND Published=1 AND Deleted=0 "
                Case "category"
                    Qry += " SELECT Description, Summary FROM Category WHERE CategoryID=" & TgtID.ToString & " AND Published=1 AND Deleted=0 "
            End Select

            Dim dt As DataTable = wGetDt(Qry)

            If dt.Rows.Count > 0 Then
                For Each dr As DataRow In dt.Rows
                    Summary = dr("Summary").ToString
                    Description = dr("Description").ToString
                Next
            End If

            Select Case LCase(Loc)
                Case "top"
                    If Summary.Length > 0 Then
                        Result = Summary
                    Else
                        If Description.Length > 0 Then
                            Result = Description
                        Else
                            Result = String.Empty
                        End If
                    End If
                Case "bot"
                    If Description.Length > 0 And Summary.Length > 0 Then
                        Result = Description
                    Else
                        Result = String.Empty
                    End If
            End Select

            Dim sb As New StringBuilder
            If Result.Length > 0 Then
                Result = Replace(Result, "<br />", "")

                sb.Append("<div class=""WsdDesc"">")

                If LCase(TgtType) = "category" And TgtID = 1349 Then
                    sb.Append(Result)
                Else
                    Select Case LCase(Loc)
                        Case "top"
                            sb.Append("<div id=""my" & Loc & "div"" class=""catalog_description expand_collapse"">")
                            sb.Append(Result)
                            sb.Append("</div>")
                            sb.Append("<div id=""my" & Loc & "divE"" class=""catalog_description_button"">")
                            sb.Append("<a href=""javascript:;"" onmousedown=""document.getElementById('my" & Loc & "div').style.height = 'auto'; document.getElementById('my" & Loc & "divC').style.display = 'block'; document.getElementById('my" & Loc & "divE').style.display = 'none';"" >Expand <img src=""/App_Templates/Skin_1/images/blue_expand.gif"" alt=""expand"" /></a>")
                            sb.Append("</div>")
                            sb.Append("<div id=""my" & Loc & "divC"" class=""catalog_description_button"" style=""display:none;"">")
                            sb.Append("<a href=""javascript:;"" onmousedown=""document.getElementById('my" & Loc & "div').style.height = '90px'; document.getElementById('my" & Loc & "divE').style.display = 'block'; document.getElementById('my" & Loc & "divC').style.display = 'none';"" >Collapse <img src=""/App_Templates/Skin_1/images/blue_collapse.gif"" alt=""collapse"" /></a>")
                            sb.Append("</div>")
                        Case "bot"
                            sb.Append("<div class=""catalog_description"">")
                            sb.Append(Result)
                            sb.Append("</div>")
                    End Select
                End If

                sb.Append("</div><br/>")

                Result = sb.ToString
                sb.Length = 0
                sb = Nothing
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetEntityContent", "app")
        End Try

        Return Result
    End Function

    Public Function wGetEntityBreadcrumb(ByVal TgtID As Integer, ByVal TgtName As String, ByVal TgtType As String, ByVal BaseUrl As String) As String
        Dim Result As String = String.Empty

        Try
            Dim ArgList As String = wGetArgList()
            'Dim CacheName As String = String.Empty

            'If AppLogic.CachingOn Then
            '    CacheName = String.Format("e_{0}_{1}_{2}", TgtID.ToString(), TgtName, TgtType)
            '    If m_EntityHT.ContainsKey(CacheName) Then
            '        Return m_EntityHT(CacheName).ToString()
            '    End If
            'End If

            Dim separator As String = "&#160;»&#160;"

            Dim hlp As EntityHelper = AppLogic.LookupHelper(TgtType, 0)
            Dim sb As New StringBuilder(1024)
            Dim ParentID As Integer = hlp.GetParentEntity(TgtID)
            'MGADD
            sb.Insert(0, "<span class=""aBreadcrumb"">" & TgtName & "</span>")
            'ENDMGADD
            Do While ParentID <> 0
                'SWANKREMOVE
                'sb.Insert(0, String.Format("<a href=""{0}"">{1}</a> {2} ", SE.MakeEntityLink(TgtType, ParentID, "") & wWriteArgList(ArgList, "zz", 0), hlp.GetEntityName(ParentID, ThisCustomer.LocaleSetting), separator))
                'ENDSWANKREMOVE
                'SWANKADD
                sb.Insert(0, String.Format("<a href=""{0}"">{1}</a> {2} ", SE.MakeEntityLink(TgtType, ParentID, ""), hlp.GetEntityName(ParentID, ThisCustomer.LocaleSetting), separator))
                'ENDSWANKADD
                ParentID = hlp.GetParentEntity(ParentID)
            Loop

            sb.Insert(0, "<p class=""breadcrumb_menu""><a href=""/"">Home</a>&#160;»&#160;")

            sb.Append("</p>")
            ' sb.Append("<h1 class=""category_title"">" & TgtName & "</h1>")

            Result = sb.ToString()

            'If AppLogic.CachingOn Then
            '    m_EntityHT.Add(CacheName, s)
            'End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetEntityBreadcrumb", "app")
        End Try

        Return Result
    End Function

    Public Function wGetEntitySub(ByVal TgtID As Integer, ByVal TgtName As String, ByVal TgtType As String) As String
        Dim Result As String = String.Empty

        Try
            Dim ArgList As String = wGetArgList()
            Dim Qry As String = String.Empty

            If LCase(TgtType) = "category" Then
                Qry += " SELECT "
                Qry += "    c.CategoryID, "
                Qry += "    c.Name, "
                Qry += "    c.SEName AS SEName, "
                Qry += "    COUNT(p.ProductID) AS ProductCount "
                Qry += " FROM Category c WITH(NoLock)"
                Qry += "    INNER JOIN ProductCategory pc ON c.CategoryID=pc.CategoryID "
                Qry += "    INNER JOIN Product p ON pc.ProductID=p.ProductID "
                Qry += "    INNER JOIN ProductVariant pv ON p.ProductID=pv.ProductID "
                Qry += " WHERE c.ParentCategoryID=" & TgtID.ToString & " "
                Qry += "    AND c.Published = 1 "
                Qry += "    AND c.Deleted = 0 "
                Qry += "    AND p.Published = 1 "
                Qry += "    AND p.Deleted = 0 "
                Qry += "    AND pv.Published = 1 "
                Qry += "    AND pv.Deleted = 0 "
                Qry += "    AND p.ShowBuyButton=1 "
                Qry += " GROUP BY "
                Qry += "    c.CategoryID, "
                Qry += "    c.Name, "
                Qry += "    c.SEName "
                Qry += " ORDER BY c.Name "

                Dim dt As DataTable = wGetDt(Qry)
                Dim sb As New StringBuilder()

                'sb.Append("<div id=""left-col"">")
                sb.Append("<div id=""specify1"" class=""cat"">")
                sb.Append("<h2>" & TgtName & "</h2>")
                If dt.Rows.Count > 0 Then
                    sb.Append("<ul>")
                    For Each dr As DataRow In dt.Rows
                        'SWANKREMOVE
                        'sb.Append("<li><a href=""" & EntityLink(dr("CategoryID"), dr("SEName"), "category", 0, "") & wWriteArgList(ArgList, "zz", 0) & """ title=""" & wGetStr(dr("Name")) & """ >" & wGetStr(dr("Name")) & " (" & wGetStr(dr("ProductCount")) & ")</a></li>")
                        'ENDSWANKREMOVE
                        'SWANKADD
                        sb.Append("<li><a href=""" & EntityLink(dr("CategoryID"), dr("SEName"), "category", 0, "") & """ title=""" & wGetStr(dr("Name")) & """ >" & wGetStr(dr("Name")) & " (" & wGetStr(dr("ProductCount")) & ")</a></li>")
                        'ENDSWANKADD
                    Next
                    sb.Append("</ul>")
                Else
                    sb.Append("<br/>There are no additional<br/>sub-categories.<br/><br/>")

                    If wGetParentCatID(TgtID) = 0 Then
                        sb.Append("<a href=""/default.aspx"" title="""" style=""font-size:11px;"">&uarr; Click here to go up a level &uarr;</a>")
                    Else
                        'SWANKREMOVE
                        'sb.Append("<a href=""" & EntityLink(wGetParentCatID(TgtID), "", "category", 0, "") & wWriteArgList(ArgList, "zz", 0) & """ title=""" & TgtName & """ style=""font-size:11px;"">&uarr; Click here to go up a level &uarr;</a>")
                        'ENDSWANKREMOVE
                        'SWANKADD
                        sb.Append("<a href=""" & EntityLink(wGetParentCatID(TgtID), "", "category", 0, "") & """ title=""" & TgtName & """ style=""font-size:11px;"">&uarr; Click here to go up a level &uarr;</a>")
                        'ENDSWANKADD
                    End If
                End If
                If dt.Rows.Count < 5 Then
                    sb.Append("<span style=""margin-bottom:25px;"">&#160;</span>")
                End If
                sb.Append("</div>")
                'sb.Append("</div>")

                Result = sb.ToString
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetEntitySub", "app")
        End Try

        Return Result
    End Function

    Public Function wGetParentCatID(ByVal CatID As Integer) As Integer
        Dim Result As Integer = 1

        Try
            Dim Qry As String = "SELECT ParentCategoryID FROM Category WHERE CategoryID = " & CatID.ToString & " "

            Dim dt As DataTable = wGetDt(Qry)

            For Each dr In dt.Rows
                Result = dr("ParentCategoryID")
            Next
        Catch ex As Exception
            wPostError(ex.ToString, "wGetParentCatID", "app")
        End Try

        Return Result
    End Function

    Public Function wGetViewBy(ByVal BaseUrl As String) As String
        Dim Result As String = String.Empty

        Try
            Dim ArgList As String = wGetArgList()
            Dim Val As String = wGetArgVal(ArgList, "vp")

            Dim sb As New StringBuilder()

            sb.Append("View: <select size=""1"" name=""ViewBy"" onchange=""location=options[selectedIndex].value;"" >")

            'SWANKREMOVE
            'If LCase(Val) = "grid" Then
            '   sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "vp", "grid") & """ selected=""selected"" >Grid</option>")
            '   sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "vp", "list") & """ >List</option>")
            'Else
            '   sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "vp", "grid") & """ >Grid</option>")
            '   sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "vp", "list") & """ selected=""selected"" >List</option>")
            'End If
            'ENDSWANKREMOVE

            'SWANKADD
            sb.Append("<option value=""" & BaseUrl & wWriteArgListForSort(ArgList, "vp", "grid") & """" & CommonLogic.IIF(LCase(Val) = "grid", " selected=""selected""", String.Empty) & ">Grid</option>")
            sb.Append("<option value=""" & BaseUrl & wWriteArgListForSort(ArgList, "vp", "list") & """" & CommonLogic.IIF(LCase(Val) = "list", " selected=""selected""", String.Empty) & ">List</option>")
            'ENDSWANKADD

            sb.Append("</select>")

            Result = sb.ToString()
            sb = Nothing
        Catch ex As Exception
            wPostError(ex.ToString, "wGetViewBy", "app")
        End Try

        Return Result
    End Function

    Public Function wGetSortBy(ByVal BaseUrl As String) As String
        Dim Result As String = String.Empty

        Try
            Dim ArgList As String = wGetArgList()
            Dim Val As String = wGetArgVal(ArgList, "sb")

            Dim sb As New StringBuilder()

            sb.Append("Sort: <select size=""1"" name=""SortBy"" onchange=""location=options[selectedIndex].value;"" >")

            'SWANKREMOVE
            'Select Case LCase(Val)
            '   Case "feature"
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "feature") & """ selected=""selected"" >Featured</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "prda") & """ >Product (A to Z)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "prdz") & """ >Product (Z to A)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "low") & """ >Price (Low to High)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "high") & """ >Price (High to Low)</option>")
            '   Case "prda"
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "feature") & """ >Featured</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "prda") & """ selected=""selected"" >Product (A to Z)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "prdz") & """ >Product (Z to A)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "low") & """ >Price (Low to High)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "high") & """ >Price (High to Low)</option>")
            '   Case "prdz"
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "feature") & """ >Featured</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "prda") & """ >Product (A to Z)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "prdz") & """ selected=""selected"" >Product (Z to A)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "low") & """ >Price (Low to High)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "high") & """ >Price (High to Low)</option>")
            '   Case "low"
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "feature") & """ >Featured</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "prda") & """ >Product (A to Z)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "prdz") & """ >Product (Z to A)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "low") & """ selected=""selected"" >Price (Low to High)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "high") & """ >Price (High to Low)</option>")
            '   Case "high"
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "feature") & """ >Featured</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "prda") & """ >Product (A to Z)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "prdz") & """ >Product (Z to A)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "low") & """ >Price (Low to High)</option>")
            '       sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "sb", "high") & """ selected=""selected"" >Price (High to Low)</option>")
            'End Select
            'ENDSWANKREMOVE

            'SWANKADD
            sb.Append("<option value=""" & BaseUrl & wWriteArgListForSort(ArgList, "sb", "feature") & """" & CommonLogic.IIF(LCase(Val) = "feature", " selected=""selected""", String.Empty) & ">Featured</option>")
            sb.Append("<option value=""" & BaseUrl & wWriteArgListForSort(ArgList, "sb", "prda") & """" & CommonLogic.IIF(LCase(Val) = "prda", " selected=""selected""", String.Empty) & ">Product (A to Z)</option>")
            sb.Append("<option value=""" & BaseUrl & wWriteArgListForSort(ArgList, "sb", "prdz") & """" & CommonLogic.IIF(LCase(Val) = "prdz", " selected=""selected""", String.Empty) & ">Product (Z to A)</option>")
            sb.Append("<option value=""" & BaseUrl & wWriteArgListForSort(ArgList, "sb", "low") & """" & CommonLogic.IIF(LCase(Val) = "low", " selected=""selected""", String.Empty) & ">Price (Low to High)</option>")
            sb.Append("<option value=""" & BaseUrl & wWriteArgListForSort(ArgList, "sb", "high") & """" & CommonLogic.IIF(LCase(Val) = "high", " selected=""selected""", String.Empty) & ">Price (High to Low)</option>")
            'ENDSWANKADD

            sb.Append("</select>")

            Result = sb.ToString()
            sb = Nothing
        Catch ex As Exception
            wPostError(ex.ToString, "wGetSortBy", "app")
        End Try

        Return Result
    End Function

    Public Function wGetItemsPerPage(ByVal BaseUrl As String) As String
        Dim Result As String = String.Empty

        Try
            Dim ArgList As String = wGetArgList()
            Dim Val As String = wGetArgVal(ArgList, "ip")

            Dim sb As New StringBuilder()

            sb.Append("Per Page: <select size=""1"" name=""ItemsPerPage"" onchange=""location=options[selectedIndex].value;"" >")

            For i As Integer = 12 To 60 Step 12
                'SWANKREMOVE
                'If i = wGetInt(Val) Then
                '   sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "ip", i.ToString) & """ selected=""selected"" >" & i.ToString & "</option>")
                'Else
                '   sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "ip", i.ToString) & """ >" & i.ToString & "</option>")
                'End If
                'ENDSWANKREMOVE

                'SWANKADD
                sb.Append("<option value=""" & BaseUrl & wWriteArgListForSort(ArgList, "ip", i.ToString) & """" & CommonLogic.IIF(i = wGetInt(Val), " selected=""selected""", String.Empty) & ">" & i.ToString & "</option>")
                'ENDSWANKADD
            Next

            sb.Append("</select>")

            Result = sb.ToString()
            sb = Nothing

        Catch ex As Exception
            wPostError(ex.ToString, "wGetItemsPerPage", "app")
        End Try

        Return Result
    End Function

    Public Function wGetPaging(ByVal TgtID As Integer, ByVal TgtType As String, ByVal BaseUrl As String, ByVal TotPgs As Double, ByVal TotPrd As Integer) As String
        Dim Result As String = String.Empty

        Try
            Dim ArgList As String = wGetArgList()

            Dim ip As Integer = wGetInt(wGetArgVal(ArgList, "ip"))
            Dim cp As Integer = wGetInt(wGetArgVal(ArgList, "cp"))

            Dim sb As StringBuilder = New StringBuilder()

            If TotPgs > 1 Then
                If cp > TotPgs Then
                    cp = TotPgs
                    'SWANKADD
                    HttpContext.Current.Response.StatusCode = 301
                    HttpContext.Current.Response.StatusDescription = "Moved Permanently"
                    HttpContext.Current.Response.Status = "301 Moved Permanently"
                    HttpContext.Current.Response.Redirect(BaseUrl & Replace(wWriteArgListForSort(ArgList, "cp", cp.ToString), "&amp;", "&"))
                    'ENDSWANKADD
                End If

                sb.Append("&nbsp;&nbsp;Page: <select size=""1"" name=""JumpToPage"" onchange=""location=options[selectedIndex].value;"" >")

                For i As Integer = 1 To TotPgs
                    'SWANKREMOVE
                    'If i = wGetInt(cp) Then
                    '    sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "cp", i.ToString) & """ selected=""selected"" >" & i.ToString & "</option>")
                    'Else
                    '    sb.Append("<option value=""" & BaseUrl & wWriteArgList(ArgList, "cp", i.ToString) & """ >" & i.ToString & "</option>")
                    'End If
                    'ENDSWANKREMOVE

                    'SWANKADD
                    sb.Append("<option value=""" & BaseUrl & wWriteArgListForSort(ArgList, "cp", i.ToString) & """" & CommonLogic.IIF(i = wGetInt(cp), " selected=""selected""", String.Empty) & ">" & i.ToString & "</option>")
                    'ENDSWANKADD
                Next

                sb.Append("</select>")
            End If

            If TotPgs = 1 Then
                sb.Append("&nbsp;&nbsp;Items 1-" & TotPrd.ToString & " of " & TotPrd.ToString & "")
            Else
                If TotPrd < ((cp - 1) * ip) + ip Then
                    sb.Append("&nbsp;&nbsp;Items " & (((cp - 1) * ip) + 1).ToString & "-" & TotPrd.ToString & " of " & TotPrd.ToString & "")
                Else
                    sb.Append("&nbsp;&nbsp;Items " & (((cp - 1) * ip) + 1).ToString & "-" & (((cp - 1) * ip) + ip).ToString & " of " & TotPrd.ToString & "")
                End If
            End If

            Result = sb.ToString
            sb = Nothing
        Catch ex As Exception
            wPostError(ex.ToString, "wGetPaging", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductList(ByVal TgtID As Integer, ByVal TgtType As String, ByVal BaseUrl As String) As String
        Dim Result As String = String.Empty

        Try
            Dim Qry As String = String.Empty
            Dim ArgList As String = wGetArgList()

            Dim TotPrd As Integer = 0

            Select Case LCase(TgtType)
                Case "manufacturer"
                    Qry += " SELECT pm.ManufacturerID, "
                    Qry += "    COUNT(*) AS TotalProducts "
                    Qry += " FROM Product p "
                    Qry += "    INNER JOIN ProductVariant pv ON p.ProductID=pv.ProductID "
                    Qry += "    INNER JOIN ProductManufacturer pm ON p.ProductID=pm.ProductID "
                Case "category"
                    Qry += " SELECT pc.CategoryID, "
                    Qry += "    COUNT(*) AS TotalProducts "
                    Qry += " FROM Product p "
                    Qry += "    INNER JOIN ProductCategory pc ON p.ProductID=pc.ProductID "
                    Qry += "    INNER JOIN ProductVariant pv ON p.ProductID=pv.ProductID "
            End Select

            Qry += " WHERE p.Published=1 "
            Qry += "    AND p.Deleted=0 "
            Qry += "    AND pv.Published=1 "
            Qry += "    AND pv.Deleted=0 "
            Qry += "    AND p.ShowBuyButton=1 "

            Select Case LCase(TgtType)
                Case "manufacturer"
                    Qry += " AND pm.ManufacturerID=" & TgtID.ToString & " "
                    Qry += " GROUP BY pm.ManufacturerID"
                Case "category"
                    Qry += " AND pc.CategoryID=" & TgtID.ToString & " "
                    Qry += " GROUP BY pc.CategoryID "
            End Select

            Dim dtPg As DataTable = wGetDt(Qry)

            For Each drPg In dtPg.Rows
                TotPrd = wGetInt(drPg("TotalProducts"))
            Next

            Dim TotPgs As Integer = 0

            Dim cp As Integer = wGetInt(wGetArgVal(ArgList, "cp"))
            Dim ip As Integer = wGetInt(wGetArgVal(ArgList, "ip"))

            TotPgs = wGetInt(Math.Ceiling(TotPrd / ip))

            If TotPgs = 0 Then
                TotPgs = 1
            End If

            If cp > TotPgs Then
                cp = TotPgs
            End If

            'SWANKADD
            ' Get original Query String Parameters from URL
            Dim q_ip As String = CommonLogic.QueryStringCanBeDangerousContent("ip") 'initial page length
            Dim q_cp As String = CommonLogic.QueryStringCanBeDangerousContent("cp") 'current page
            Dim q_sb As String = CommonLogic.QueryStringCanBeDangerousContent("sb") 'sort by
            Dim q_vp As String = CommonLogic.QueryStringCanBeDangerousContent("vp") 'view page list / grid

            ' Let's eliminate those we do not need and build a new URL of Parameters
            If q_ip = "24" Or q_cp = "1" Or q_sb = "feature" Or q_vp = "grid" Then
                ' Redirect!
                HttpContext.Current.Response.StatusCode = 301
                HttpContext.Current.Response.StatusDescription = "Moved Permanently"
                HttpContext.Current.Response.Status = "301 Moved Permanently"
                HttpContext.Current.Response.Redirect(BaseUrl & Replace(wWriteArgListForSort(ArgList, "cp", cp.ToString), "&amp;", "&"))
            End If
            'ENDSWANKADD

            Qry = String.Empty
            Qry += " SELECT "
            Qry += "    ProductID, "
            Qry += "    VariantID, "
            Qry += "    Name, "
            Qry += "    SEName, "
            Qry += "    ImageFileNameOverride, "
            Qry += "    Skusuffix, "
            Qry += "    DisplayOrder, "
            Qry += "    Price, "
            Qry += "    SalePrice, "
            Qry += "    ExtendedPrice, "
            Qry += "    BestSeller "
            Qry += " FROM "
            Qry += " ( "

            Qry += " SELECT "
            Qry += "	p.ProductID, "
            Qry += "	pv.VariantID, "
            Qry += "	LTRIM(p.Name) AS Name, "
            Qry += "	p.SEName, "
            Qry += "	p.ImageFilenameOverride, "
            Qry += "	pv.Skusuffix, "
            Qry += "	tf.DisplayOrder, "
            Qry += "	ISNULL(pv.Price,0) AS Price, "
            Qry += "	ISNULL(pv.SalePrice,0) AS SalePrice, "
            Qry += "	ISNULL(ep.Price,0) AS ExtendedPrice, "
            Qry += "	ISNULL(bs.ProductID,0) AS BestSeller "
            Qry += " FROM Product p "

            Select Case LCase(TgtType)
                Case "manufacturer"
                    Qry += "	INNER JOIN ProductVariant pv ON p.ProductID=pv.ProductID "
                    Qry += "	INNER JOIN ProductManufacturer tf ON p.ProductID=tf.ProductID "
                    'Qry += "	LEFT OUTER JOIN ExtendedPrice ep ON pv.VariantID=ep.VariantID AND ep.CustomerLevelID=" & ThisCustomer.CustomerLevelID & " "
                    Qry += "	LEFT OUTER JOIN ExtendedPrice ep ON pv.VariantID=ep.VariantID AND ep.CustomerLevelID=" & wGetCustomerLevelID() & " "
                    Qry += "	LEFT OUTER JOIN "
                    Qry += "	( "
                    Qry += "        SELECT TOP 8 sc.ProductID "
                    Qry += "        FROM Orders_ShoppingCart sc INNER JOIN ProductManufacturer pm ON sc.ProductID=pm.ProductID AND pm.ManufacturerID=" & TgtID.ToString & " "
                    Qry += "        WHERE OrderNumber>104870 "
                    Qry += "        GROUP BY sc.ProductID "
                    Qry += "        Order BY SUM(Quantity) DESC "
                    Qry += "	) bs ON p.ProductID=bs.ProductID "
                    Qry += " WHERE tf.ManufacturerID=" & TgtID.ToString & " "
                Case "category"
                    Qry += "	INNER JOIN ProductVariant pv ON p.ProductID=pv.ProductID "
                    Qry += "	INNER JOIN ProductCategory tf ON p.ProductID=tf.ProductID "
                    'Qry += "	LEFT OUTER JOIN ExtendedPrice ep ON pv.VariantID=ep.VariantID AND ep.CustomerLevelID=" & ThisCustomer.CustomerLevelID & " "
                    Qry += "	LEFT OUTER JOIN ExtendedPrice ep ON pv.VariantID=ep.VariantID AND ep.CustomerLevelID=" & wGetCustomerLevelID() & " "
                    Qry += "	LEFT OUTER JOIN "
                    Qry += "	( "
                    Qry += "        SELECT TOP 8 sc.ProductID "
                    Qry += "        FROM Orders_ShoppingCart sc INNER JOIN ProductCategory pc ON sc.ProductID=pc.ProductID AND pc.CategoryID=" & TgtID.ToString & " "
                    Qry += "        WHERE OrderNumber>104870 "
                    Qry += "        GROUP BY sc.ProductID "
                    Qry += "        Order BY SUM(Quantity) DESC "
                    Qry += "	) bs ON p.ProductID=bs.ProductID "
                    Qry += " WHERE tf.CategoryID=" & TgtID.ToString & " "
            End Select

            Qry += "	AND p.Published=1 "
            Qry += "	AND p.Deleted=0 "
            Qry += "	AND pv.Published=1 "
            Qry += "	AND pv.Deleted=0 "
            Qry += "	AND p.ShowBuyButton=1 "
            Qry += " ) AS Product "

            Select Case wGetArgVal(ArgList, "sb")
                Case "feature"
                    Qry += " ORDER BY DisplayOrder "
                Case "prda"
                    Qry += " ORDER BY Name "
                Case "prdz"
                    Qry += " ORDER BY Name DESC "
                Case "low"
                    Qry += " ORDER BY Price "
                Case "high"
                    Qry += " ORDER BY Price DESC "
            End Select

            Dim dtPr As DataTable = wGetDt(Qry, cp, ip)

            If dtPr.Rows.Count > 0 Then
                Dim sb As New StringBuilder

                'Write out filter row
                Dim f0 As String = String.Empty
                f0 += wGetViewBy(BaseUrl) & "&#160;&#160;"
                f0 += wGetSortBy(BaseUrl) & "&#160;&#160;"
                f0 += wGetItemsPerPage(BaseUrl) & "&#160;&#160;"
                f0 += wGetPaging(TgtID, TgtType, BaseUrl, TotPgs, TotPrd)

                sb.Append("<div id=""WsdFilterTop"" class=""WsdFilterList"">" & f0 & "</div>")
                sb.Append(wGetProductTbl(dtPr, 560, 4, wGetArgVal(ArgList, "vp"), "product"))
                sb.Append("<div class=""WsdFilterList"">" & f0 & "</div>")

                Result = sb.ToString

                sb.Length = 0
                sb = Nothing
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductList", "app")
        End Try

        Return Result
    End Function

    Private Function wGetProductTbl(ByVal dtPr As DataTable, ByVal Wid As Integer, ByVal Col As Integer, ByVal Display As String, ByVal Type As String) As String
        Dim Result As String = String.Empty

        Try
            Dim ProductID As Integer = 0
            Dim VariantID As Integer = 0
            Dim Name As String = String.Empty
            Dim SEName As String = String.Empty
            Dim SkuSuffix As String = String.Empty
            Dim ImageFileNameOverride As String = String.Empty
            Dim Price As Decimal = Decimal.Zero
            Dim SalePrice As Decimal = Decimal.Zero
            Dim ExtendedPrice As Decimal = Decimal.Zero
            Dim Bestseller As Integer = 0

            Dim sb As StringBuilder = New StringBuilder

            Dim Pos As Integer = 0

            Dim t0t As String = String.Empty
            Dim t0b As String = String.Empty

            Dim r0t As String = String.Empty
            Dim r0b As String = String.Empty

            Select Case LCase(Display)
                Case "list"
                    sb.Append("<br/><table width=""" & Wid.ToString & """ border=""0"" cellspacing=""0"" cellpadding=""0"" class=""MiscTbl"">")

                    For Each drPr As DataRow In dtPr.Rows
                        Pos += 1

                        ProductID = wGetInt(drPr("ProductID"))
                        VariantID = wGetInt(drPr("VariantID"))
                        Name = Replace(wGetStr(drPr("Name")), """", "&quot;")
                        SEName = wGetStr(drPr("SEName"))
                        SkuSuffix = wGetStr(drPr("SkuSuffix"))
                        ImageFileNameOverride = wGetStr(drPr("ImageFileNameOverride"))
                        Price = wGetDec(drPr("Price"))
                        SalePrice = wGetDec(drPr("SalePrice"))
                        ExtendedPrice = wGetDec(drPr("ExtendedPrice"))
                        Bestseller = wGetInt(drPr("Bestseller"))

                        sb.Append("<tr style=""height:55px;""><td style=""padding-left:5px;padding-right:5px;"">")
                        sb.Append("<a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """>" & wLookupProductImage(ProductID, ImageFileNameOverride, SkuSuffix, Name, "mini") & "</a>" & vbCrLf)
                        sb.Append("</td><td>")
                        sb.Append("<a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """>" & Name & "</a>" & vbCrLf)
                        sb.Append("</td><td align=""center"">")
                        sb.Append("<span class=""price_red"">" & FormatCurrency(wDetermineLevelPrice(VariantID, wGetCustomerLevelID(), Price, SalePrice, ExtendedPrice)) & "</span><br/>" & vbCrLf)
                        sb.Append("<div class=""prod-but""><a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """></a></div>" & vbCrLf)
                        sb.Append("</td></tr>")
                        sb.Append("<tr><td colspan=""3"" style=""border-top:1px solid #000000""></td></tr>")
                    Next
                    sb.Append("</table><br/>")
                Case "grid"
                    Select Case LCase(Type)
                        Case "product"
                            sb.Append("<div id=""cat-list"">")
                        Case "related"
                            sb.Append("<div id=""cat-list"" class=""moveleft"">")
                            sb.Append("<h3>Related Products</h3>")
                        Case "bought"
                            sb.Append("<div id=""cat-list"" class=""moveleft"">")
                            sb.Append("<h3>Customers Who Bought This Product Also Bought The Following:</h3>")
                        Case Else
                            sb.Append("<div id=""cat-list"">")
                    End Select

                    sb.Append("<table width=""" & Wid.ToString & """ border=""0"" cellspacing=""0"" cellpadding=""0"">")

                    For Each drPr As DataRow In dtPr.Rows
                        Pos += 1

                        ProductID = wGetInt(drPr("ProductID"))
                        VariantID = wGetInt(drPr("VariantID"))
                        Name = Replace(wGetStr(drPr("Name")), """", "&quot;")
                        SEName = wGetStr(drPr("SEName"))
                        SkuSuffix = wGetStr(drPr("SkuSuffix"))
                        ImageFileNameOverride = wGetStr(drPr("ImageFileNameOverride"))
                        Price = wGetDec(drPr("Price"))
                        SalePrice = wGetDec(drPr("SalePrice"))
                        ExtendedPrice = wGetDec(drPr("ExtendedPrice"))
                        Bestseller = wGetInt(drPr("Bestseller"))

                        t0t = wGetProductTdTop(ProductID, Name, SEName, SkuSuffix, ImageFileNameOverride, Bestseller)
                        t0b = wGetProductTdBot(ProductID, VariantID, Name, SEName, Price, SalePrice, ExtendedPrice)

                        If Pos = 1 Then
                            r0t += "<tr>"
                            r0b += "<tr>"
                        End If

                        r0t += t0t
                        r0b += t0b

                        If Pos = Col Then
                            r0t += "</tr>"
                            r0b += "</tr>"

                            sb.Append(r0t & r0b)

                            r0t = String.Empty
                            r0b = String.Empty

                            Pos = 0
                        End If

                        t0t = String.Empty
                        t0b = String.Empty
                    Next

                    If Pos > 0 And Pos < Col Then
                        For i As Integer = Pos + 1 To Col
                            r0t += "<td class=""prod-info""></td>"
                            r0b += "<td class=""prod-info""></td>"
                        Next

                        r0t += "</tr>"
                        r0b += "</tr>"

                        sb.Append(r0t & r0b)

                        r0t = String.Empty
                        r0b = String.Empty
                    End If

                    sb.Append("</table>")
                    sb.Append("</div>")
            End Select

            Result = sb.ToString

            sb.Length = 0
            sb = Nothing
        Catch ex As Exception
            Return ex.ToString
            wPostError(ex.ToString, "wGetProductTbl", "app")
        End Try

        Return Result
    End Function

    Private Function wGetProductTdTop(ByVal ProductID As Integer, ByVal Name As String, ByVal SEName As String, ByVal SkuSuffix As String, ByVal ImageFileNameOverride As String, ByVal Bestseller As Integer) As String
        Dim Result As String = String.Empty

        Try
            Dim sb As StringBuilder = New StringBuilder

            If Bestseller > 0 Then
                sb.Append("<td class=""best-sell"">" & vbCrLf)
            Else
                sb.Append("<td>" & vbCrLf)
            End If

            sb.Append("<a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """>" & wLookupProductImage(ProductID, ImageFileNameOverride, SkuSuffix, Name, "icon") & "</a>" & vbCrLf)
            sb.Append("</td>" & vbCrLf)

            Result = sb.ToString

            sb.Length = 0
            sb = Nothing
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductTdTop", "app")
        End Try

        Return Result
    End Function

    Private Function wGetProductTdBot(ByVal ProductID As Integer, ByVal VariantID As Integer, ByVal Name As String, ByVal SEName As String, ByVal Price As Decimal, ByVal SalePrice As Decimal, ByVal ExtendedPrice As Decimal) As String
        Dim Result As String = String.Empty

        Try
            Dim sb As StringBuilder = New StringBuilder

            sb.Append("<td class=""prod-info"" valign=""top"">" & vbCrLf)
            sb.Append("<div class=""prod-more""><a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """>More Info</a></div>" & vbCrLf)
            sb.Append("<div class=""prod-but""><a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """></a></div>" & vbCrLf)
            sb.Append("<br/><br/>" & vbCrLf)
            sb.Append("<a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """>" & Name & "</a>" & vbCrLf)
            sb.Append("<br/>" & vbCrLf)
            sb.Append("<span class=""price_red"">" & FormatCurrency(wDetermineLevelPrice(VariantID, wGetCustomerLevelID(), Price, SalePrice, ExtendedPrice)) & "</span>" & vbCrLf)
            sb.Append("</td>" & vbCrLf)

            Result = sb.ToString

            sb.Length = 0
            sb = Nothing
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductTdBot", "app")
        End Try

        Return Result
    End Function

    'Original
    'Public Function wGetProductList(ByVal TgtID As Integer, ByVal TgtType As String, ByVal BaseUrl As String) As String
    '    Dim Result As String = String.Empty

    '    Try
    '        Dim Qry As String = String.Empty
    '        Dim ArgList As String = wGetArgList()

    '        '******************************************************
    '        'Get total number of products for list
    '        '******************************************************
    '        Dim TotPrd As Integer = 0

    '        Select Case LCase(TgtType)
    '            Case "manufacturer"
    '                Qry += " SELECT pm.ManufacturerID, "
    '            Case "category"
    '                Qry += " SELECT pc.CategoryID, "
    '        End Select

    '        Qry += "    COUNT(*) AS TotalProducts "
    '        Qry += " FROM Product p "
    '        Qry += "    INNER JOIN ProductCategory pc ON p.ProductID=pc.ProductID "
    '        Qry += "    INNER JOIN ProductVariant pv ON p.ProductID=pv.ProductID "
    '        Qry += "    INNER JOIN ProductManufacturer pm ON p.ProductID=pm.ProductID "
    '        Qry += " WHERE p.Published=1 "
    '        Qry += "    AND p.Deleted=0 "
    '        Qry += "    AND pv.Published=1 "
    '        Qry += "    AND pv.Deleted=0 "
    '        Qry += "    AND p.ShowBuyButton=1 "

    '        Select Case LCase(TgtType)
    '            Case "manufacturer"
    '                Qry += " AND pm.ManufacturerID=" & TgtID.ToString & " "
    '                Qry += " GROUP BY pm.ManufacturerID"
    '            Case "category"
    '                Qry += " AND pc.CategoryID=" & TgtID.ToString & " "
    '                Qry += " GROUP BY pc.CategoryID "
    '        End Select

    '        Dim dtPg As DataTable = wGetDt(Qry)

    '        For Each drPg In dtPg.Rows
    '            TotPrd = wGetInt(drPg("TotalProducts"))
    '        Next

    '        '******************************************************
    '        'Get total pages
    '        '******************************************************
    '        Dim TotPgs As Integer = 0

    '        Dim cp As Integer = wGetInt(wGetArgVal(ArgList, "cp"))
    '        Dim ip As Integer = wGetInt(wGetArgVal(ArgList, "ip"))

    '        TotPgs = wGetInt(Math.Ceiling(TotPrd / ip))

    '        'check for one page of products
    '        If TotPgs = 0 Then
    '            TotPgs = 1
    '        End If

    '        'make sure that current page is not greater than total pages dues to filter changes
    '        If cp > TotPgs Then
    '            cp = TotPgs
    '        End If

    '        '******************************************************
    '        'Get products for list by current page
    '        '******************************************************
    '        Qry = String.Empty
    '        Qry += " SELECT "
    '        Qry += "    ProductID, "
    '        Qry += "    VariantID, "
    '        Qry += "    LTRIM(Name) AS NAME, "
    '        Qry += "    SEName, "
    '        Qry += "    ImageFileNameOverride, "
    '        Qry += "    Skusuffix, "
    '        Qry += "    DisplayOrder, "
    '        Qry += "    Price, "
    '        Qry += "    SalePrice, "
    '        Qry += "    ExtendedPrice, "
    '        Qry += "    BestSeller "
    '        Qry += " FROM "
    '        Qry += " ( "

    '        Qry += " SELECT "
    '        Qry += "	p.ProductID, "
    '        Qry += "	pv.VariantID, "
    '        Qry += "	p.Name, "
    '        Qry += "	p.SEName, "
    '        Qry += "	p.ImageFilenameOverride, "
    '        Qry += "	pv.Skusuffix, "
    '        Qry += "	pc.DisplayOrder, "
    '        Qry += "	ISNULL(pv.Price,0) AS Price, "
    '        Qry += "	ISNULL(pv.SalePrice,0) AS SalePrice, "
    '        Qry += "	ISNULL(ep.Price,0) AS ExtendedPrice, "
    '        Qry += "	ISNULL(bs.ProductID,0) AS BestSeller "
    '        Qry += " FROM Product p "
    '        Qry += "	INNER JOIN ProductCategory pc ON p.ProductID=pc.ProductID "
    '        Qry += "	INNER JOIN ProductVariant pv ON p.ProductID=pv.ProductID "
    '        Qry += "	INNER JOIN ProductManufacturer pm ON p.ProductID=pm.ProductID "
    '        Qry += "	LEFT OUTER JOIN ExtendedPrice ep ON pv.VariantID=ep.VariantID AND ep.CustomerLevelID=" & ThisCustomer.CustomerLevelID & " "
    '        Qry += "	LEFT OUTER JOIN "
    '        Qry += "	( "

    '        Select Case LCase(TgtType)
    '            Case "manufacturer"
    '                Qry += " SELECT TOP 8 sc.ProductID "
    '                Qry += " FROM Orders_ShoppingCart sc INNER JOIN ProductManufacturer pm ON sc.ProductID=pm.ProductID AND pm.ManufacturerID=" & TgtID.ToString & " "
    '                Qry += " WHERE OrderNumber>104870 "
    '                Qry += " GROUP BY sc.ProductID "
    '                Qry += " Order BY SUM(Quantity) DESC "
    '            Case "category"
    '                Qry += " SELECT TOP 8 sc.ProductID "
    '                Qry += " FROM Orders_ShoppingCart sc INNER JOIN ProductCategory pc ON sc.ProductID=pc.ProductID AND pc.CategoryID=" & TgtID.ToString & " "
    '                Qry += " WHERE OrderNumber>104870 "
    '                Qry += " GROUP BY sc.ProductID "
    '                Qry += " Order BY SUM(Quantity) DESC "
    '        End Select

    '        Qry += "	) bs ON p.ProductID=bs.ProductID "

    '        Select Case LCase(TgtType)
    '            Case "manufacturer"
    '                Qry += " WHERE pm.ManufacturerID=" & TgtID.ToString & " "
    '            Case "category"
    '                Qry += " WHERE pc.CategoryID=" & TgtID.ToString & " "
    '        End Select

    '        Qry += "	AND p.Published=1 "
    '        Qry += "	AND p.Deleted=0 "
    '        Qry += "	AND pv.Published=1 "
    '        Qry += "	AND pv.Deleted=0 "
    '        Qry += "	AND p.ShowBuyButton=1 "
    '        Qry += " ) AS Product "

    '        Select Case wGetArgVal(ArgList, "sb")
    '            Case "feature"
    '                'Qry += " ORDER BY ROW_NUMBER() OVER(ORDER BY DisplayOrder) "
    '                Qry += " ORDER BY DisplayOrder "
    '            Case "prda"
    '                'Qry += " ORDER BY ROW_NUMBER() OVER(ORDER BY LTRIM(Name)) "
    '                Qry += " ORDER BY LTRIM(Name) "
    '            Case "prdz"
    '                'Qry += " ORDER BY ROW_NUMBER() OVER(ORDER BY LTRIM(Name) DESC) "
    '                Qry += " ORDER BY LTRIM(Name) DESC "
    '            Case "low"
    '                'Qry += " ORDER BY ROW_NUMBER() OVER(ORDER BY Price) "
    '                Qry += " ORDER BY Price "
    '            Case "high"
    '                'Qry += " ORDER BY ROW_NUMBER() OVER(ORDER BY Price DESC) "
    '                Qry += " ORDER BY Price DESC "
    '        End Select

    '        Dim dtPr As DataTable = wGetDt(Qry, cp, ip)

    '        If dtPr.Rows.Count > 0 Then
    '            Dim sb As New StringBuilder

    '            Dim ProductID As Integer = 0
    '            Dim VariantID As Integer = 0
    '            Dim Name As String = String.Empty
    '            Dim SEName As String = String.Empty
    '            Dim SkuSuffix As String = String.Empty
    '            Dim ImageFileNameOverride As String = String.Empty
    '            Dim Price As Decimal = Decimal.Zero
    '            Dim SalePrice As Decimal = Decimal.Zero
    '            Dim ExtendedPrice As Decimal = Decimal.Zero
    '            Dim Bestseller As Integer = 0

    '            'Write out filter row
    '            Dim f0 As String = String.Empty
    '            f0 += wGetViewBy(BaseUrl) & "&#160;&#160;"
    '            f0 += wGetSortBy(BaseUrl) & "&#160;&#160;"
    '            f0 += wGetItemsPerPage(BaseUrl) & "&#160;&#160;"
    '            f0 += wGetPaging(TgtID, TgtType, BaseUrl, TotPgs, TotPrd)

    '            'Position in table (left to right, values 1 thru 4)
    '            Dim Pos As Integer = 1

    '            'Hold tmp td data for each position (top or bottom)
    '            Dim t0t As String = String.Empty
    '            Dim t0b As String = String.Empty

    '            'Position 1-4 top and bottom td's
    '            Dim p1t As String = String.Empty
    '            Dim p2t As String = String.Empty
    '            Dim p3t As String = String.Empty
    '            Dim p4t As String = String.Empty
    '            Dim p1b As String = String.Empty
    '            Dim p2b As String = String.Empty
    '            Dim p3b As String = String.Empty
    '            Dim p4b As String = String.Empty

    '            If wGetArgVal(ArgList, "vp") = "grid" Then
    '                sb.Append("<div id=""WsdFilterTop"" class=""WsdFilterList"">" & f0 & "</div>")
    '                sb.Append("<div id=""cat-list"">")
    '                sb.Append("<table width=""560"" border=""0"" cellspacing=""0"" cellpadding=""0"">")

    '                For Each drPr As DataRow In dtPr.Rows
    '                    ProductID = wGetInt(drPr("ProductID"))
    '                    VariantID = wGetInt(drPr("VariantID"))
    '                    Name = Replace(wGetStr(drPr("Name")), """", "&quot;")
    '                    SEName = wGetStr(drPr("SEName"))
    '                    SkuSuffix = wGetStr(drPr("SkuSuffix"))
    '                    ImageFileNameOverride = wGetStr(drPr("ImageFileNameOverride"))
    '                    Price = wGetDec(drPr("Price"))
    '                    SalePrice = wGetDec(drPr("SalePrice"))
    '                    ExtendedPrice = wGetDec(drPr("ExtendedPrice"))
    '                    Bestseller = wGetInt(drPr("Bestseller"))

    '                    If Pos = 5 Then
    '                        Pos = 1
    '                        sb.Append("<tr>")
    '                        sb.Append(p1t & p2t & p3t & p4t)
    '                        sb.Append("</tr>")
    '                        sb.Append("<tr>")
    '                        sb.Append(p1b & p2b & p3b & p4b)
    '                        sb.Append("</tr>")
    '                    End If

    '                    If Bestseller > 0 Then
    '                        t0t += "<td class=""best-sell"">" & vbCrLf
    '                    Else
    '                        t0t += "<td>" & vbCrLf
    '                    End If

    '                    t0t += "<a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """>" & wLookupProductImage(ProductID, ImageFileNameOverride, SkuSuffix, Name, "icon") & "</a>" & vbCrLf
    '                    t0t += "</td>" & vbCrLf

    '                    t0b += "<td class=""prod-info"" valign=""top"">" & vbCrLf
    '                    t0b += "<div class=""prod-more""><a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """>More Info</a></div>" & vbCrLf
    '                    t0b += "<div class=""prod-but""><a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """></a></div>" & vbCrLf
    '                    t0b += "<br/><br/>" & vbCrLf
    '                    t0b += "<a href=""" & ProductLink(ProductID, SEName, "False") & """ title=""" & Name & """>" & Name & "</a>" & vbCrLf
    '                    t0b += "<br/>" & vbCrLf
    '                    t0b += "<span class=""price_red"">" & FormatCurrency(wDetermineLevelPrice(VariantID, wGetCustomerLevelID(), Price, SalePrice, ExtendedPrice)) & "</span>" & vbCrLf
    '                    t0b += "</td>" & vbCrLf

    '                    Select Case Pos
    '                        Case 1
    '                            p1t = t0t
    '                            p1b = t0b
    '                        Case 2
    '                            p2t = t0t
    '                            p2b = t0b
    '                        Case 3
    '                            p3t = t0t
    '                            p3b = t0b
    '                        Case 4
    '                            p4t = t0t
    '                            p4b = t0b
    '                    End Select

    '                    t0t = String.Empty
    '                    t0b = String.Empty

    '                    Pos += 1
    '                Next

    '                sb.Append("</table>")
    '                sb.Append("</div>")
    '                sb.Append("<div class=""WsdFilterList"">" & f0 & "</div>")
    '            End If
    '            Result = sb.ToString

    '            sb.Length = 0
    '            sb = Nothing
    '        End If
    '    Catch ex As Exception
    '        wPostError(ex.ToString, "wGetProductList", "app")
    '    End Try

    '    Return Result
    'End Function


    Public Function wGetArgList() As String
        Dim Result As String = String.Empty

        Try
            Dim ip As String = CommonLogic.QueryStringCanBeDangerousContent("ip") 'initial page length
            Dim cp As String = CommonLogic.QueryStringCanBeDangerousContent("cp") 'current page
            Dim sb As String = CommonLogic.QueryStringCanBeDangerousContent("sb") 'sort by
            Dim vp As String = CommonLogic.QueryStringCanBeDangerousContent("vp") 'view page list / grid

            If ip.Length = 0 Then
                ip = 24
            End If

            If cp.Length = 0 Then
                cp = 1
            End If

            If sb.Length = 0 Then
                sb = "feature"
            End If

            If vp.Length = 0 Then
                vp = "grid"
            End If

            Result = "ip=" & ip & "|cp=" & cp & "|sb=" & sb & "|vp=" & vp & ""
        Catch ex As Exception
            wPostError(ex.ToString, "wGetArgList", "app")
        End Try

        Return Result
    End Function

    Private Function wGetArgVal(ByVal ArgList As String, ByVal Tgt As String) As String
        Dim Result As String = String.Empty

        Try
            Dim ArgArr As Array = Split(ArgList, "|")

            For i As Integer = 0 To UBound(ArgArr)
                If Left(ArgArr(i), 2) = Tgt Then
                    Result = Replace(ArgArr(i), Tgt & "=", "")
                    Exit For
                End If
            Next
        Catch ex As Exception
            wPostError(ex.ToString, "wGetArgVal", "app")
        End Try

        Return Result
    End Function

    Private Function wWriteArgList(ByVal ArgList As String, ByVal Tgt As String, ByVal Val As String) As String
        Dim Result As String = String.Empty

        Try
            Dim ArgArr As Array = Split(ArgList, "|")

            Result = "?"

            For i As Integer = 0 To UBound(ArgArr)
                If Left(ArgArr(i), 2) = Tgt Then
                    Result += "&amp;" & Left(ArgArr(i), 2) & "=" & Val
                Else
                    Result += "&amp;" & ArgArr(i)
                End If
            Next

            Result = Replace(Result, "?&amp;", "?")
        Catch ex As Exception
            wPostError(ex.ToString, "wWriteArgList", "app")
        End Try

        Return Result
    End Function

    'SWANKADD
    Private Function wWriteArgListForSort(ByVal ArgList As String, ByVal Tgt As String, ByVal Val As String) As String
        Dim Result As String = String.Empty

        Try
            Dim ArgArr As Array = Split(ArgList, "|")

            For i As Integer = 0 To UBound(ArgArr)

                Dim ThisKeyVal As Array = Split(ArgArr(i), "=")
                Dim ThisKey As String = ThisKeyVal(0)
                Dim ThisVal As String = CommonLogic.IIF(ThisKey = Tgt, Val, ThisKeyVal(1))

                ' If query string parameters are set to their default, we do not need to include them 
                If Not (ThisKey = "ip" And ThisVal = "24") And Not (ThisKey = "cp" And ThisVal = "1") And Not (ThisKey = "sb" And ThisVal = "feature") And Not (ThisKey = "vp" And ThisVal = "grid") Then
                    Result &= CommonLogic.IIF(Result.Length > 0, "&amp;", String.Empty) & ThisKey & "=" & ThisVal
                End If

            Next

            If Result.Length > 0 Then
                Result = "?" & Result
            End If

        Catch ex As Exception
            wPostError(ex.ToString, "wWriteArgList", "app")
        End Try

        Return Result
    End Function
    'ENDSWANKADD

    'Product Functions
    Public Function wGetProductBreadcrumb(ByVal ProductID As Integer, ByVal ProductName As String, ByVal TgtType As String, ByVal TgtID As Integer) As String
        Dim Result As String = String.Empty

        Try
            'Dim CacheName As String = String.Empty
            'If AppLogic.CachingOn Then
            '    CacheName = String.Format("p_{0}_{1}_{2}_{3}", ProductID.ToString(), TgtType, TgtID.ToString(), ThisCustomer.LocaleSetting)
            '    If m_ProductHT.ContainsKey(CacheName) Then
            '        Return m_ProductHT(CacheName).ToString()
            '    End If
            'End If

            Dim separator As String = "&#160;»&#160;"

            Dim sb As New StringBuilder(2048)

            If TgtID <> 0 Then
                Dim hlp As EntityHelper = AppLogic.LookupHelper(TgtType, 0)
                Dim ThisID As Integer = TgtID
                Do While ThisID <> 0
                    sb.Insert(0, String.Format("<a href=""{0}"">{1}</a> {2} ", SE.MakeEntityLink(TgtType, ThisID, ""), hlp.GetEntityName(ThisID, ThisCustomer.LocaleSetting), separator))
                    ThisID = hlp.GetParentEntity(ThisID)
                Loop
            End If

            sb.Insert(0, "<a href=""/"">Home</a>&#160;»&#160;")
            sb.Insert(0, "<p class=""breadcrumb_menu"">")
            sb.Append("</p>")

            Result = sb.ToString()

            'If AppLogic.CachingOn Then
            '    ' possible race condition... check again...
            '    If m_ProductHT.ContainsKey(CacheName) = False Then
            '        m_ProductHT.Add(CacheName, s)
            '    End If
            'End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductBreadcrumb", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductImage(ByVal ProductID As Integer, ByVal ImageFileNameOverride As String, ByVal SkuSuffix As String, ByVal Product As String, ByVal DesiredSize As String) As String
        Dim Result As String = String.Empty

        Try
            Result = wLookupProductImage(ProductID, ImageFileNameOverride, SkuSuffix, Product, DesiredSize)
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductImage", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductPrice(ByVal VariantID As Integer, ByVal Msrp As Decimal, ByVal Price As Decimal, ByVal SalePrice As Decimal) As String
        Dim Result As String = String.Empty

        Try
            Dim ExtendedPrice As Decimal = Decimal.Zero

            Dim dtE As DataTable = wGetDt("SELECT Price FROM ExtendedPrice WHERE CustomerLevelID=" & wGetCustomerLevelID().ToString & " AND VariantID=" & VariantID.ToString & " ")

            If dtE.Rows.Count = 1 Then
                For Each dr As DataRow In dtE.Rows
                    ExtendedPrice = wGetDec(dr("Price"))
                Next
            End If

            Dim FinalPrice As Decimal = wDetermineLevelPrice(VariantID, wGetCustomerLevelID(), Price, SalePrice, ExtendedPrice)

            Dim DiscountPercent As Decimal = 0D

            DiscountPercent = 1 - (FinalPrice / Msrp)

            Result += "<tr class=""online-price"">"
            Result += "<td width=""200"">Average Online Price:</td>"
            Result += "<td align=""right"">" & FormatCurrency(Msrp) & "</td>"
            Result += "</tr>"

            Result += "<tr class=""sale-price"">"
            Result += "<td width=""200"">Today's Sale Price:</td>"
            Result += "<td align=""right"">" & FormatCurrency(FinalPrice) & "</td>"
            Result += "</tr>"

            Result += "<tr class=""you-save"">"
            Result += "<td width=""200"">You Save:</td>"
            Result += "<td align=""right"">" & FormatPercent(DiscountPercent, 0) & "</td>"
            Result += "</tr>"

        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductPrice", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductQuote(ByVal VariantID As Integer) As String
        Dim Result As String = String.Empty

        Try
            Result += "<script type=""text/javascript"">" & vbCrLf
            Result += "<!--" & vbCrLf
            Result += "function PopQuote(VariantID) {" & vbCrLf
            Result += "window.open('wQuote.aspx?VariantID=' + VariantID, 'PopQuote', 'directories=0,location=0,menubar=0,toolbar=0,resizable=1,scrollbars=1,status=1,width=700,height=500');" & vbCrLf
            Result += "}" & vbCrLf
            Result += "-->" & vbCrLf
            Result += "</script>" & vbCrLf
            Result += "<p>" & vbCrLf
            Result += "<img src=""/App_Templates/Skin_1/Images/quote.gif"" alt=""Bulk Quote"" width=""20"" height=""20"">" & vbCrLf
            Result += "&#160;<a href=""javascript:PopQuote(" & VariantID & ");"">Bulk Quote</a>" & vbCrLf
            Result += "</p>" & vbCrLf
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductQuote", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductShipping(ByVal VariantID As Integer) As String
        Dim Result As String = String.Empty

        Try
            Result += "<script type=""text/javascript"">" & vbCrLf
            Result += "<!--" & vbCrLf
            Result += "function PopEstimateShipping(VariantID) {" & vbCrLf
            Result += "window.open('wEstimateShipping.aspx?VariantID=' + VariantID, 'PopEstimateShipping', 'toolbar=0,resizable=1,scrollbars=1,status=1,width=700,height=410');" & vbCrLf
            Result += "}" & vbCrLf
            Result += "-->" & vbCrLf
            Result += "</script>" & vbCrLf
            Result += "<p>" & vbCrLf
            Result += "<img src=""/App_Templates/Skin_1/Images/shipping.gif"" alt=""Estimate Shipping"" width=""20"" height=""20"">" & vbCrLf
            Result += "&#160;<a href=""javascript:PopEstimateShipping(" & VariantID & ");"">Estimate Shipping</a>" & vbCrLf
            Result += "</p>" & vbCrLf
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductShipping", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductMsds(ByVal wMsdsFile As String) As String
        Dim Result As String = String.Empty

        Try
            If wMsdsFile.Length > 0 Then
                If FileExists(m_DowloadPath & "Msds\" & wMsdsFile) Then
                    Result += "<p>"
                    Result += "<img src=""/App_Templates/Skin_1/Images/pdficon_small.gif"" alt=""Material Safety Data Sheet Informatione"" width=""20"" height=""20"">"
                    Result += "&#160;<a onclick=""this.target='" & wMsdsFile & "';"" href=""/Download/Msds/" & wMsdsFile & """>MSDS</a>"
                    Result += "</p>"
                End If
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductMsds", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductCatalogPage(ByVal wCatalogPage As String) As String
        Dim Result As String = String.Empty

        Try
            If wCatalogPage.Length > 0 Then

                Select Case wCatalogPage.Trim.Length
                    Case 1
                        wCatalogPage = "00" & wCatalogPage
                    Case 2
                        wCatalogPage = "0" & wCatalogPage
                End Select

                If FileExists(m_DowloadPath & "Catalog\2012\LS12_" & wCatalogPage & "_NON.pdf") Then
                    Result += "<p>" & vbCrLf
                    Result += "<img src=""/App_Templates/Skin_1/Images/book_icon.gif"" alt=""Catalog Page"" width=""20"" height=""20"">"
                    Result += "&#160;<a onclick=""this.target='" & wCatalogPage & "';"" href=""/Download/Catalog/2012/LS12_" & wCatalogPage & "_NON.pdf"">View Catalog</a>"
                    Result += "</p>" & vbCrLf
                End If
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductCatalogPage", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductWeight(ByVal Weight As Decimal) As String
        Dim Result As String = String.Empty

        Try
            If Weight <> Decimal.Zero Then
                Result = FormatNumber(Weight, 2).ToString & " lbs"
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductWeight", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductAvailable(ByVal Inventory As Integer) As String
        Dim Result As String = String.Empty

        Try
            If Inventory < 1 Then
                Result = "<font color=red><b>OUT OF STOCK</b></font>"
            Else
                Result = "In Stock"

                If Inventory < 200 Then
                    Result += " <font color=red><b>(" & Inventory.ToString & ")</b></font>"
                End If
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductAvailable", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductLtl(ByVal wIsLtl As Integer) As String
        Dim Result As String = String.Empty

        Try
            If wIsLtl = 1 Then
                Result = "<br/><br/><font color=red>Product cannot be shipped by UPS, Will be shipped common carrier.</font>"
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductLtl", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductFreeShip(ByVal FreeShipping As Integer) As String
        Dim Result As String = String.Empty

        Try
            If FreeShipping = 1 Then
                Result = "<br/><br/><font color=red>Free Shipping for this product!</font>"
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductFreeShip", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductHazard(ByVal RequiresProducts As String) As String
        Dim Result As String = String.Empty

        Try
            If RequiresProducts.Contains("9578") Then
                Result = "<br/><br/><font color=red>Product contains hazardous material.  Additional handling charge of $45.00 will be added at checkout.</font>"
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductHazard", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductRebate(ByVal RebateName As String, ByVal RebateFile As String) As String
        Dim Result As String = String.Empty

        Try
            If RebateName.Length > 0 And RebateFile.Length > 0 Then
                If FileExists(m_DowloadPath & "Rebate\" & RebateFile) Then
                    Result += "<table width=""75%"" align=""center""><tr>"
                    Result += "<td><a href='/Download/Rebate/" & RebateFile & "' target='" & RebateFile & "'><img src='/App_Templates/Skin_1/Images/Rebate.gif' align='middle' alt='" & HtmlEncode(RebateName) & "'></a></td>"
                    Result += "<td><a href='/Download/Rebate/" & RebateFile & "' target='" & RebateFile & "'>Download the <b>""" & RebateName & """</b> Mail-In Rebate Form</a></td>"
                    Result += "</tr></table>"
                    Result += "<br/>"
                End If
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductRebate", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductVideo(ByVal VideoName As String, ByVal VideoFile As String, ByVal VideoType As String) As String
        Dim Result As String = String.Empty

        Try
            If VideoName.Length > 0 And VideoFile.Length > 0 And VideoType.Length > 0 Then
                Select Case LCase(VideoType)
                    Case "youtube"
                        Result = "<iframe title=""" & VideoName & """ class=""youtube-player"" type=""text/html"" width=""320"" height=""240"" src=""https://www.youtube.com/embed/" & VideoFile & "?rel=0"" frameborder=""0"" allowFullScreen></iframe>"
                End Select
                Result += "<br/>"
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductVideo", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductQuestion(ByVal VariantID As Integer) As String
        Dim Result As String = String.Empty

        Try
            Result += "<script type=""text/javascript"">" & vbCrLf
            Result += "<!--" & vbCrLf
            Result += "function PopQuestion(VariantID) {" & vbCrLf
            Result += "window.open('wQuestion.aspx?VariantID=' + VariantID, 'PopQuestion', 'directories=0,location=0,menubar=0,toolbar=0,resizable=1,scrollbars=1,status=1,width=700,height=410');" & vbCrLf
            Result += "}" & vbCrLf
            Result += "-->" & vbCrLf
            Result += "</script>" & vbCrLf
            Result += "<img src=""/App_Templates/Skin_1/Images/question.gif"" alt=""Ask a Question"" width=""20"" height=""20"">" & vbCrLf
            Result += "&#160;<a href=""javascript:PopQuestion(" & VariantID & ");"">Ask a Question</a>" & vbCrLf
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductQuestion", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductEmail(ByVal VariantID As Integer) As String
        Dim Result As String = String.Empty

        Try
            Result += "<script type=""text/javascript"">" & vbCrLf
            Result += "<!--" & vbCrLf
            Result += "function PopEmailFriend(VariantID) {" & vbCrLf
            Result += "window.open('wEmailFriend.aspx?VariantID=' + VariantID, 'PopEmailFriend', 'directories=0,location=0,menubar=0,toolbar=0,resizable=1,scrollbars=1,status=1,width=700,height=410');" & vbCrLf
            Result += "}" & vbCrLf
            Result += "-->" & vbCrLf
            Result += "</script>" & vbCrLf
            Result += "<img src=""/App_Templates/Skin_1/Images/email_icon.gif"" alt=""Email A Friend"" width=""20"" height=""20"">" & vbCrLf
            Result += "&#160;<a href=""javascript:PopEmailFriend(" & VariantID & ");"">Email A Friend</a>" & vbCrLf
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductEmail", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductBookmark() As String
        Dim Result As String = String.Empty

        Try
            Result += "<script type=""text/javascript"">"
            Result += "function bookmarksite(title, url) { if (document.all) window.external.AddFavorite(url, title); else if (window.sidebar) window.sidebar.addPanel(title, url, """") }"
            Result += "</script>"

            Result += "<img src=""/App_Templates/Skin_1/Images/fav.gif"" alt=""Add To Favorites"" width=""20"" height=""20"">" & vbCrLf
            Result += "&#160;<a href=""javascript:bookmarksite('CleanItSupply.com', 'http://www.cleanitsupply.com')"">Add To Favorites</a>" & vbCrLf
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductBookmark", "app")
        End Try

        Return Result
    End Function

    Public Function wGetProductFacebook(ByVal SETitle As String, ByVal SEName As String, ByVal ProductID As Integer) As String
        Dim Result As String = String.Empty

        Dim Url As String = "http://www.cleanitsupply.com/p-" & ProductID.ToString & "-" & SEName.ToString & ".aspx"
        Dim Title As String = SETitle

        Result = "<img src=""/App_Templates/Skin_1/Images/facebook.jpg"" alt=""Share on Facebook"" border=""0"" /><a onclick=""this.target='_blank';"" href=""http://www.facebook.com/sharer.php?u=" & Url & "&t=" & Title & """>Share on Facebook</a>"

        Return Result
    End Function

    Public Function wGetProductTwitter(ByVal SEName As String, ByVal ProductID As Integer) As String
        Dim Result As String = String.Empty

        Dim Url As String = "http://www.cleanitsupply.com/p-" & ProductID.ToString & "-" & SEName.ToString & ".aspx"

        Result += "<img src=""/App_Templates/Skin_1/Images/twitter.gif"" alt=""Share On Facebook"" width=""20"" height=""20"">" & vbCrLf
        Result += "<a onclick=""this.target='_blank';"" href=""http://twitter.com/home?status=Currently reading " & Url & """>Share on Twitter</a>"

        Return Result
    End Function

    Public Function wGetProductPrint() As String
        Dim Result As String = String.Empty

        Result += "<img src=""/App_Templates/Skin_1/Images/print.gif"" alt=""Print Page"" width=""20"" height=""20"">" & vbCrLf
        Result += "&#160;<a href=""javascript:window.print()"">Print Page</a>" & vbCrLf

        Return Result
    End Function

    Public Function wGetProductFacebookLike(ByVal SEName As String, ByVal ProductID As Integer) As String
        Dim Result As String = String.Empty

        Dim Url As String = "http://www.cleanitsupply.com/p-" & ProductID.ToString & "-" & SEName.ToString & ".aspx"

        Result += "<fb:like href=""" & Url & """ layout=""standard"" show_faces=""false"" width=""260"" action=""like"" font=""arial"" colorscheme=""light""></fb:like>"

        Return Result
    End Function

    Public Function wGetProductGooglePlus() As String
        Dim Result As String = String.Empty

        Result += "<g:plusone></g:plusone>"
        Result += "<script type=""text/javascript"">"
        Result += "(function() {"
        Result += "     var po = document.createElement('script'); po.type = 'text/javascript'; po.async = true;"
        Result += "	    po.src = 'https://apis.google.com/js/plusone.js';"
        Result += "	    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(po, s);"
        Result += "})();"
        Result += "</script>"

        Return Result
    End Function

    Public Function wGetProductRelated(ByVal RelatedProducts As String) As String
        Dim Result As String = String.Empty

        Try
            If RelatedProducts.Length > 0 Then
                Dim Qry As String = String.Empty

                Qry += " SELECT "
                Qry += "    p.ProductID, "
                Qry += "    pv.VariantID, "
                Qry += "    p.Name, "
                Qry += "    p.SEName, "
                Qry += "    p.ImageFilenameOverride, "
                Qry += "    pv.Skusuffix, "
                Qry += "    pv.Name AS Variant, "
                Qry += "    ISNULL(pv.Price,0) AS Price, "
                Qry += "    ISNULL(pv.SalePrice,0) AS SalePrice, "
                Qry += "    ISNULL(ep.Price,0) AS ExtendedPrice, "
                Qry += "    pm.ManufacturerID, "
                Qry += "    0 AS Bestseller "
                Qry += " FROM Product p "
                Qry += "    INNER JOIN ProductVariant pv ON p.ProductID=pv.ProductID "
                Qry += "    INNER JOIN ProductManufacturer pm ON p.ProductID=pm.ProductID "
                Qry += "    LEFT OUTER JOIN ExtendedPrice ep ON pv.VariantID=ep.VariantID AND ep.CustomerLevelID=" & ThisCustomer.CustomerLevelID & " "
                Qry += " WHERE p.ProductID IN (" & RelatedProducts & ")"
                Qry += "    AND p.Published=1 "
                Qry += "    AND p.Deleted=0 "
                Qry += "    AND pv.Published=1 "
                Qry += "    AND pv.Deleted=0 "
                Qry += "    AND p.ShowBuyButton=1 "

                Dim dt As DataTable = wGetDt(Qry)

                If dt.Rows.Count > 0 Then
                    Result = wGetProductTbl(dt, 715, 5, "grid", "related")
                End If
            End If
        Catch ex As Exception
        End Try

        Return Result
    End Function

    Public Function wGetProductBought(ByVal BoughtID As Integer) As String
        Dim Result As String = String.Empty

        Try
            Dim Qry As String = String.Empty

            Qry += " SELECT TOP 10 "
            Qry += "    p.ProductID, "
            Qry += "    pv.VariantID, "
            Qry += "    p.Name, "
            Qry += "    p.SEName, "
            Qry += "    p.ImageFilenameOverride, "
            Qry += "    pv.Skusuffix, "
            Qry += "    pv.Name AS Variant, "
            Qry += "    ISNULL(pv.Price,0) AS Price, "
            Qry += "    ISNULL(pv.SalePrice,0) AS SalePrice, "
            Qry += "    ISNULL(ep.Price,0) AS ExtendedPrice, "
            Qry += "    pm.ManufacturerID, "
            Qry += "    0 AS Bestseller "
            Qry += " FROM Product p "
            Qry += "    INNER JOIN ProductVariant pv ON p.ProductID=pv.ProductID "
            Qry += "    INNER JOIN ProductManufacturer pm ON p.ProductID=pm.ProductID "
            Qry += "    INNER JOIN "
            Qry += "    ( "
            Qry += "        SELECT TOP 100 PERCENT sc1.OrderedProductSKU, SUM(sc1.Quantity) AS Quantity "
            Qry += "        FROM Orders_ShoppingCart sc1 "
            Qry += "        INNER JOIN Orders_ShoppingCart sc2 ON sc1.OrderNumber=sc2.OrderNumber "
            Qry += "        INNER JOIN ProductVariant pv2 ON sc2.OrderedProductSKU=pv2.Skusuffix "
            Qry += "        WHERE sc1.OrderedProductSKU <>'' AND pv2.ProductID = " & BoughtID.ToString & " "
            Qry += "        GROUP BY sc1.OrderedProductSKU "
            Qry += "        ORDER BY SUM(sc1.Quantity) DESC "
            Qry += "    ) "
            Qry += "    sc ON pv.SKUSuffix = sc.OrderedProductSKU "
            Qry += "    LEFT OUTER JOIN ExtendedPrice ep ON pv.VariantID=ep.VariantID AND ep.CustomerLevelID=" & ThisCustomer.CustomerLevelID & " "
            Qry += " WHERE p.Published=1 "
            Qry += "    AND p.Deleted=0 "
            Qry += "    AND pv.Published=1 "
            Qry += "    AND pv.Deleted=0 "
            Qry += "    AND p.ShowBuyButton=1 "

            Dim dt As DataTable = wGetDt(Qry)

            If dt.Rows.Count > 0 Then
                Result = wGetProductTbl(dt, 715, 5, "grid", "bought")
            End If
        Catch ex As Exception
            Return ex.ToString
            'Do something here
        End Try

        Return Result
    End Function

    Public Function wGetProductDiscontinue(ByVal ProductID As Integer, ByVal Product As String, ByVal SEName As String, ByVal TgtID As Integer, ByVal TgtType As String, ByVal TgtName As String) As String
        Dim Result As String = String.Empty

        Try
            Dim sb As New StringBuilder()

            sb.Append("<br/><br/><b>This product is out of stock or has been discontinued.</b><br/><br/>")
            sb.Append("If you need assistance finding a replacement product,<br/>please give us a call at 1-800-998-3295 or send<br/>an email to <a href=""mailto:info@cleanitsupply.com"">info@cleanitsupply.com</a>.<br/><br/>")
            sb.Append("<a href=""nsearch.aspx?keywords=" & Replace(SEName, "-", " ").ToString & """>Click Here</a> if you would like to search for similar products.<br/><br/>")
            sb.Append("<a href=""" & SE.MakeEntityLink(TgtType, TgtID, "") & """>Click Here</a> to view products in the <b>" & TgtName & "</b> category.")

            Result = sb.ToString()

            sb = Nothing
        Catch ex As Exception
            wPostError(ex.ToString, "wGetProductDiscontinue", "app")
        End Try

        Return Result
    End Function

    Public Function wGetAddToCartForm(ByVal ProductID As Integer, ByVal VariantID As Integer) As String
        Dim Result As String = String.Empty

        Try
            '**************************
            'WSD - custom
            '**************************
            'Declare local vars for values not passed to function
            Dim forPack As Boolean = False
            Dim forKit As Boolean = False
            Dim showWishListButton As Boolean = False
            Dim showGiftRegistryButton As Boolean = False
            Dim SkinID As Integer = ThisCustomer.SkinID
            Dim DisplayFormat As Integer = 0
            Dim LocaleSetting As String = ThisCustomer.LocaleSetting
            Dim ColorChangeProductImage As Boolean = False
            Dim VariantStyle As VariantStyleEnum = VariantStyleEnum.RegularVariantsWithAttributes
            Dim packID As Integer = 0
            '**************************
            'WSD - custom
            '**************************

            'Not supported in Ml express
            If AppLogic.ProductIsMLExpress() = True Then
                showWishListButton = False
                showGiftRegistryButton = False
            End If

            Dim CartRecID As Integer = CommonLogic.QueryStringUSInt("CartRecID")
            Dim TextOptionForEdit As String = String.Empty
            Dim QuantityForEdit As Integer = 0
            Dim ChosenSizeForEdit As String = String.Empty
            Dim ChosenColorForEdit As String = String.Empty
            Dim ProductPriceForEdit As Decimal = Decimal.Zero
            If CartRecID <> 0 Then
                Using con As New SqlConnection(DB.GetDBConn())
                    con.Open()
                    Using rscart As IDataReader = DB.GetRS("select * from ShoppingCart where ShoppingCartRecID=" & CartRecID.ToString() & " and VariantID = " & VariantID.ToString(), con)
                        If rscart.Read() Then
                            TextOptionForEdit = DB.RSField(rscart, "TextOption")
                            QuantityForEdit = DB.RSFieldInt(rscart, "Quantity")
                            ChosenSizeForEdit = DB.RSFieldByLocale(rscart, "ChosenSize", Localization.GetDefaultLocale())
                            ChosenColorForEdit = DB.RSFieldByLocale(rscart, "ChosenColor", Localization.GetDefaultLocale())
                            ProductPriceForEdit = DB.RSFieldDecimal(rscart, "ProductPrice")
                        End If
                    End Using
                End Using
            End If

            Dim ProductSku As String = String.Empty
            Dim SkuSuffix As String = String.Empty
            Dim CustomerEntersPrice As Boolean = False
            Dim CustomerEntersPricePrompt As String = String.Empty
            Dim RestrictedQuantities As String = String.Empty
            Dim MinimumQuantity As Integer = 0
            Dim TrackInventoryBySizeAndColor As Boolean = False
            Dim TrackInventoryByColor As Boolean = False
            Dim ColorsMaster As String = String.Empty
            Dim ColorsDisplay As String = String.Empty
            Dim ColorSKUModifiers As String = String.Empty
            Dim ColorOptionPrompt As String = String.Empty
            Dim TrackInventoryBySize As Boolean = False
            Dim SizesMaster As String = String.Empty
            Dim SizesDisplay As String = String.Empty
            Dim SizeSKUModifiers As String = String.Empty
            Dim SizeOptionPrompt As String = String.Empty
            Dim HasSizePriceModifiers As Boolean = False
            Dim HasColorPriceModifiers As Boolean = False
            Dim boardSuffix As String = String.Empty
            Dim TextOptionPrompt As String = String.Empty
            Dim TextOptionMaxLength As Integer = 0
            Dim TaxClassID As Integer = 0
            Dim SKU As String = String.Empty
            Dim ExtensionData As String = String.Empty
            Dim ExtensionData2 As String = String.Empty
            Dim IsRecurring As Boolean = False
            Dim IsDownload As Boolean = False
            Dim ShowTextOption As Boolean = False
            Dim RequiresTextOption As Boolean = False

            Using con As New SqlConnection(DB.GetDBConn())
                con.Open()
                Using rs As IDataReader = DB.GetRS("select PV.*,P.*, pv.Sizes MLSizes, pv.Colors MLColors, p.ColorOptionPrompt MLColorOptionPrompt, p.SizeOptionPrompt MLSizeOptionPrompt, p.TextOptionPrompt MLTextOptionPrompt, p.TextOptionMaxLength from Product P  with (NOLOCK)  left outer join productvariant PV  with (NOLOCK)  on p.productid=pv.productid where PV.ProductID=P.ProductID and pv.VariantID=" & VariantID.ToString(), con)
                    If Not rs.Read() Then
                        rs.Close()
                        Return String.Empty
                    End If
                    If (Not AppLogic.AppConfigBool("ShowBuyButtons")) OrElse (Not DB.RSFieldBool(rs, "showbuybutton")) OrElse AppLogic.HideForWholesaleSite(ThisCustomer.CustomerLevelID) Then
                        Return "&nbsp;"
                    End If
                    If DB.RSFieldBool(rs, "IsCallToOrder") Then
                        'Return "<form style=""margin-top: 0px; margin-bottom: 0px;""><font class=""CallToOrder"">" & AppLogic.GetString("common.cs.67", SkinID, LocaleSetting) & "</font></form>" ' use <form></form> to give same spacing that normal add to cart would have
                        Return "<span class=""MiscCallToOrder"">&nbsp;" & AppLogic.GetString("common.cs.67", SkinID, LocaleSetting) & "&nbsp;</font>"
                    End If

                    ProductSku = DB.RSField(rs, "SKU").Trim()
                    SkuSuffix = DB.RSField(rs, "SkuSuffix").Trim()
                    CustomerEntersPrice = DB.RSFieldBool(rs, "CustomerEntersPrice")
                    CustomerEntersPricePrompt = DB.RSFieldByLocale(rs, "CustomerEntersPricePrompt", ThisCustomer.LocaleSetting)
                    RestrictedQuantities = DB.RSField(rs, "RestrictedQuantities")
                    MinimumQuantity = DB.RSFieldInt(rs, "MinimumQuantity")

                    TrackInventoryBySizeAndColor = DB.RSFieldBool(rs, "TrackInventoryBySizeAndColor")

                    TrackInventoryByColor = DB.RSFieldBool(rs, "TrackInventoryByColor")
                    ColorsMaster = DB.RSFieldByLocale(rs, "MLColors", Localization.GetDefaultLocale()).Trim()
                    ColorsDisplay = DB.RSFieldByLocale(rs, "MLColors", LocaleSetting).Trim()
                    ColorSKUModifiers = DB.RSField(rs, "ColorSKUModifiers").Trim()
                    ColorOptionPrompt = DB.RSFieldByLocale(rs, "MLColorOptionPrompt", LocaleSetting).Trim()

                    TrackInventoryBySize = DB.RSFieldBool(rs, "TrackInventoryBySize")
                    SizesMaster = DB.RSFieldByLocale(rs, "MLSizes", Localization.GetDefaultLocale()).Trim()
                    SizesDisplay = DB.RSFieldByLocale(rs, "MLSizes", LocaleSetting).Trim()
                    SizeSKUModifiers = DB.RSField(rs, "SizeSKUModifiers").Trim()
                    SizeOptionPrompt = DB.RSFieldByLocale(rs, "MLSizeOptionPrompt", LocaleSetting).Trim()

                    If SizesDisplay.Length = 0 Then
                        SizesDisplay = SizesMaster
                    End If

                    If ColorsDisplay.Length = 0 Then
                        ColorsDisplay = ColorsMaster
                    End If

                    HasSizePriceModifiers = SizesMaster.IndexOf("["c) <> -1
                    HasColorPriceModifiers = ColorsMaster.IndexOf("["c) <> -1
                    boardSuffix = String.Format("_{0}_{1}", ProductID.ToString(), VariantID.ToString())

                    TextOptionPrompt = DB.RSFieldByLocale(rs, "MLTextOptionPrompt", LocaleSetting).Trim()
                    TextOptionMaxLength = DB.RSFieldInt(rs, "TextOptionMaxLength")

                    TaxClassID = DB.RSFieldInt(rs, "TaxClassID")

                    SKU = DB.RSField(rs, "SKU")

                    ExtensionData = DB.RSField(rs, "ExtensionData")
                    ExtensionData2 = DB.RSField(rs, "ExtensionData2")

                    IsRecurring = DB.RSFieldBool(rs, "IsRecurring")
                    IsDownload = DB.RSFieldBool(rs, "IsDownload")

                    If VariantStyle = VariantStyleEnum.ERPWithRollupAttributes Then
                        Dim d As New XmlDocument()

                        Using conn2 As New SqlConnection(DB.GetDBConn())
                            conn2.Open()
                            Using rsx As IDataReader = DB.GetRS("select ExtensionData,ExtensionData2 from Product with (NOLOCK) where ProductID=" & DB.RSFieldInt(rs, "ProductID").ToString(), conn2)
                                rsx.Read()
                                ColorSKUModifiers = String.Empty
                                SizeSKUModifiers = String.Empty
                                Try
                                    d.LoadXml(DB.RSField(rsx, "ExtensionData2"))
                                Catch
                                End Try
                            End Using
                        End Using

                        For Each n As XmlNode In d.SelectNodes("GroupAttributes/GroupAttribute")
                            Dim AttrName As String = XmlCommon.XmlAttribute(n, "Name")
                            If AttrName.Equals("ATTR1", StringComparison.InvariantCultureIgnoreCase) Then
                                SizeOptionPrompt = XmlCommon.XmlAttribute(n, "Prompt")
                                Dim Separator As String = String.Empty
                                For Each nn As XmlNode In n.SelectNodes("Values/Value")
                                    SizesMaster &= Separator
                                    SizesMaster &= nn.InnerText
                                    Separator = ","
                                Next nn
                            ElseIf AttrName.Equals("ATTR2", StringComparison.InvariantCultureIgnoreCase) Then
                                ColorOptionPrompt = XmlCommon.XmlAttribute(n, "Prompt")
                                Dim Separator As String = String.Empty
                                For Each nn As XmlNode In n.SelectNodes("Values/Value")
                                    ColorsMaster &= Separator
                                    ColorsMaster &= nn.InnerText
                                    Separator = ","
                                Next nn
                            End If
                        Next n
                        SizesDisplay = SizesMaster
                        ColorsDisplay = ColorsMaster
                    End If

                    If TextOptionMaxLength = 0 Then
                        TextOptionMaxLength = 50
                    End If
                    If ColorOptionPrompt.Length = 0 Then
                        ColorOptionPrompt = AppLogic.GetString("AppConfig.ColorOptionPrompt", SkinID, LocaleSetting)
                    End If
                    If ColorOptionPrompt.Length = 0 Then
                        ColorOptionPrompt = AppLogic.GetString("common.cs.68", SkinID, LocaleSetting)
                    End If
                    If SizeOptionPrompt.Length = 0 Then
                        SizeOptionPrompt = AppLogic.GetString("AppConfig.SizeOptionPrompt", SkinID, LocaleSetting)
                    End If
                    If SizeOptionPrompt.Length = 0 Then
                        SizeOptionPrompt = AppLogic.GetString("common.cs.69", SkinID, LocaleSetting)
                    End If
                    If TextOptionPrompt.Length = 0 Then
                        TextOptionPrompt = AppLogic.AppConfig("TextOptionPrompt")
                    End If
                    If TextOptionPrompt.Length = 0 Then
                        TextOptionPrompt = AppLogic.GetString("common.cs.70", SkinID, LocaleSetting)
                    End If
                    ShowTextOption = False
                    RequiresTextOption = DB.RSFieldBool(rs, "RequiresTextOption")
                    If RequiresTextOption OrElse DB.RSFieldByLocale(rs, "TextOptionPrompt", LocaleSetting).Trim().Length <> 0 Then
                        ShowTextOption = True
                    End If
                End Using
            End Using

            If ColorChangeProductImage Then
                Dim ig As New ProductImageGallery(ProductID, ThisCustomer.SkinID, ThisCustomer.LocaleSetting, SKU)
                ColorChangeProductImage = Not ig.IsEmpty()
            End If

            Dim FormName As String = "AddToCartForm_" & ProductID.ToString() & "_" & VariantID.ToString()

            Dim ProtectInventory As Boolean = AppLogic.AppConfigBool("Inventory.LimitCartToQuantityOnHand")
            Dim ProtectInventoryMinQuantity As Integer = AppLogic.AppConfigUSInt("Inventory.MinQuantity") ' if qty is below this, addtocart will not allow it
            Dim InventoryControlList As String = String.Empty
            If ProtectInventory Then
                InventoryControlList = AppLogic.GetInventoryList(ProductID, VariantID, TrackInventoryByColor, TrackInventoryBySize, ProductSku, SkuSuffix, SizesMaster, ColorsMaster)
            End If

            Dim inv As Integer = AppLogic.GetInventory(ProductID, VariantID, "", "")

            Dim tmpS As New StringBuilder(10000)
            tmpS.Append("<div>" & vbLf)
            tmpS.Append("<script type=""text/javascript"" Language=""JavaScript"">" & vbLf & "<!--" & vbLf)
            tmpS.Append("var VariantMinimumQty_" & ProductID.ToString() & "_" & VariantID.ToString() & " = " & MinimumQuantity.ToString() & ";" & vbLf)
            tmpS.Append("var SelectedVariantInventory_" & ProductID.ToString() & "_" & VariantID.ToString() & " = " & inv.ToString() & ";" & vbLf)


            If ProtectInventory AndAlso InventoryControlList.Length <> 0 Then
                Dim first As Boolean = True
                For Each s As String In InventoryControlList.Split("|"c)
                    If first Then
                        tmpS.Append("var board" & boardSuffix & " = new Array(")
                    Else
                        tmpS.Append(",")
                    End If
                    Dim ivals() As String = s.Split(","c)
                    tmpS.Append("new Array('" & ivals(0).Replace("'", "").Trim() & "','" & ivals(1).Replace("'", "").Trim() & "','" & ivals(2).Replace("'", "").Trim() & "')")
                    first = False
                Next s
                tmpS.Append(");" & vbLf)
            End If

            tmpS.Append("function " & FormName & "_Validator(theForm)" & vbLf)
            tmpS.Append("	{" & vbLf)
            tmpS.Append("	submitonce(theForm);" & vbLf)

            If (Not CustomerEntersPrice) AndAlso (AppLogic.AppConfigBool("ShowQuantityOnProductPage") AndAlso (Not forKit)) OrElse ((Not AppLogic.AppConfigBool("HideKitQuantity")) AndAlso forKit) Then
                tmpS.AppendFormat("	if ((theForm.Quantity_{0}_{1}.value*1) < 1)" & vbLf, ProductID, VariantID) ' convert form val to integer
                tmpS.Append("	{" & vbLf)
                tmpS.Append("		alert(""" & AppLogic.GetString("common.cs.84", SkinID, LocaleSetting) & """);" & vbLf)
                tmpS.AppendFormat("		theForm.Quantity_{0}_{1}.focus();" & vbLf, ProductID, VariantID)
                tmpS.Append("		submitenabled(theForm);" & vbLf)
                tmpS.Append("		return (false);" & vbLf)
                tmpS.Append("    }" & vbLf)

                If RestrictedQuantities.Length = 0 AndAlso MinimumQuantity <> 0 Then
                    tmpS.AppendFormat("	if ((theForm.Quantity_{0}_{1}.value*1) < VariantMinimumQty_" & ProductID.ToString() & "_" & VariantID.ToString() & ")" & vbLf, ProductID, VariantID) ' convert form val to integer
                    tmpS.Append("	{" & vbLf)
                    tmpS.Append("		alert(""" & String.Format(AppLogic.GetString("common.cs.85", SkinID, LocaleSetting), """+VariantMinimumQty_" & ProductID.ToString() & "_" & VariantID.ToString() & " + """) & """);" & vbLf)
                    tmpS.AppendFormat("		theForm.Quantity_{0}_{1}.focus();" & vbLf, ProductID, VariantID)
                    tmpS.Append("		submitenabled(theForm);" & vbLf)
                    tmpS.Append("		return (false);" & vbLf)
                    tmpS.Append("    }" & vbLf)
                End If
            End If

            If SizesMaster.Length <> 0 AndAlso (Not AppLogic.AppConfigBool("AutoSelectFirstSizeColorOption")) Then
                tmpS.AppendFormat("	if (theForm.Size_{0}_{1}.selectedIndex < 1)" & vbLf, ProductID, VariantID)
                tmpS.Append("	{" & vbLf)
                tmpS.Append("		alert(""" & String.Format(AppLogic.GetString("common.cs.71", SkinID, LocaleSetting), SizeOptionPrompt.ToLowerInvariant()) & """);" & vbLf)
                tmpS.AppendFormat("		theForm.Size_{0}_{1}.focus();" & vbLf, ProductID, VariantID)
                tmpS.Append("		submitenabled(theForm);" & vbLf)
                tmpS.Append("		return (false);" & vbLf)
                tmpS.Append("    }" & vbLf)
            End If
            If ColorsMaster.Length <> 0 AndAlso (Not AppLogic.AppConfigBool("AutoSelectFirstSizeColorOption")) Then
                tmpS.AppendFormat("	if (theForm.Color_{0}_{1}.selectedIndex < 1)" & vbLf, ProductID, VariantID)
                tmpS.Append("	{" & vbLf)
                tmpS.Append("		alert(""" & String.Format(AppLogic.GetString("common.cs.71", SkinID, LocaleSetting), ColorOptionPrompt.ToLowerInvariant()) & """);" & vbLf)
                tmpS.AppendFormat("		theForm.Color_{0}_{1}.focus();" & vbLf, ProductID, VariantID)
                tmpS.Append("		submitenabled(theForm);" & vbLf)
                tmpS.Append("		return (false);" & vbLf)
                tmpS.Append("    }" & vbLf)
            End If
            If RequiresTextOption Then
                tmpS.AppendFormat("	if (theForm.TextOption_{0}_{1}.value.length == 0)" & vbLf, ProductID, VariantID)
                tmpS.Append("	{" & vbLf)
                tmpS.Append("		alert(""" & String.Format(AppLogic.GetString("common.cs.73", SkinID, LocaleSetting), TextOptionPrompt) & """);" & vbLf)
                tmpS.AppendFormat("		theForm.TextOption_{0}_{1}.focus();" & vbLf, ProductID, VariantID)
                tmpS.AppendFormat("		submitenabled(theForm);" & vbLf)
                tmpS.Append("		return (false);" & vbLf)
                tmpS.Append("    }" & vbLf)
            End If

            If VariantStyle = VariantStyleEnum.RegularVariantsWithAttributes AndAlso ProtectInventory AndAlso AppLogic.AppConfigBool("ShowQuantityOnProductPage") Then
                If Not TrackInventoryBySizeAndColor Then
                    tmpS.AppendFormat("	if (theForm.Quantity_{0}_{1}.value > SelectedVariantInventory_" & ProductID.ToString() & "_" & VariantID.ToString() & ")" & vbLf, ProductID, VariantID)
                    tmpS.Append("	{" & vbLf)
                    tmpS.Append("		alert(""" & String.Format(AppLogic.GetString("common.cs.74", SkinID, LocaleSetting), """+SelectedVariantInventory_" & ProductID.ToString() & "_" & VariantID.ToString() & "+""") & """);" & vbLf)
                    tmpS.AppendFormat("		theForm.Quantity_{0}_{1}.value = SelectedVariantInventory_" & ProductID.ToString() & "_" & VariantID.ToString() & ";" & vbLf, ProductID, VariantID)
                    tmpS.AppendFormat("		theForm.Quantity_{0}_{1}.focus();" & vbLf, ProductID, VariantID)
                    tmpS.Append("		submitenabled(theForm);" & vbLf)
                    tmpS.Append("		return (false);" & vbLf)
                    tmpS.Append("    }" & vbLf)
                Else
                    If SizesMaster.Length <> 0 Then
                        tmpS.AppendFormat("var sel_size = theForm.Size_{0}_{1}[theForm.Size_{0}_{1}.selectedIndex].value;" & vbLf, ProductID, VariantID)
                        'JH 10.21.2010 removed append parameters that did not match formatting. This also matches the js builder below
                        tmpS.Append("sel_size = sel_size.substring(0,sel_size.indexOf(',')).replace(new RegExp(""'"", 'gi'), '');" & vbLf)
                    Else
                        tmpS.Append("var sel_size = '';" & vbLf)
                    End If

                    If ColorsMaster.Length <> 0 Then
                        tmpS.AppendFormat("var sel_color = theForm.Color_{0}_{1}[theForm.Color_{0}_{1}.selectedIndex].value;" & vbLf, ProductID, VariantID)
                        tmpS.Append("sel_color = sel_color.substring(0,sel_color.indexOf(',')).replace(new RegExp(""'"", 'gi'), '');" & vbLf)
                    Else
                        tmpS.Append("var sel_color = '';" & vbLf)
                    End If

                    tmpS.Append("if(typeof(sel_size) == 'undefined') sel_size = '';" & vbLf)
                    tmpS.Append("if(typeof(sel_color) == 'undefined') sel_color = '';" & vbLf)

                    ' clean price delta options if any, so match will work on inventory control list:
                    tmpS.Append("var j = sel_size.indexOf(""["");" & vbLf)
                    tmpS.Append("if(j != -1)" & vbLf)
                    tmpS.Append("{" & vbLf)
                    tmpS.Append("	sel_size = Trim(sel_size.substring(0,j));" & vbLf)
                    tmpS.Append("}" & vbLf)

                    tmpS.Append("var i = sel_color.indexOf(""["");" & vbLf)
                    tmpS.Append("if(i != -1)" & vbLf)
                    tmpS.Append("{" & vbLf)
                    tmpS.Append("	sel_color = Trim(sel_color.substring(0,i));" & vbLf)
                    tmpS.Append("}" & vbLf)

                    If TrackInventoryBySize Then
                        tmpS.Append("var sel_size_master = sel_size;" & vbLf)
                    Else
                        tmpS.Append("var sel_size_master = '';" & vbLf)
                    End If

                    If TrackInventoryByColor Then
                        tmpS.Append("var sel_color_master = sel_color;" & vbLf)
                    Else
                        tmpS.Append("var sel_color_master = '';" & vbLf)
                    End If

                    tmpS.AppendFormat("var sel_qty = theForm.Quantity_{0}_{1}.value;" & vbLf, ProductID, VariantID)
                    tmpS.Append("var sizecolorfound = 0;" & vbLf)
                    tmpS.Append("for(i = 0; i < board" & boardSuffix & ".length; i++)" & vbLf)
                    tmpS.Append("{" & vbLf)
                    tmpS.Append("	if(board" & boardSuffix & "[i][1] == sel_size_master && board" & boardSuffix & "[i][0] == sel_color_master)" & vbLf)
                    tmpS.Append("	{" & vbLf)
                    tmpS.Append("		sizecolorfound = 1;" & vbLf)
                    tmpS.Append("		if(parseInt(sel_qty) > parseInt(board" & boardSuffix & "[i][2]))" & vbLf)
                    tmpS.Append("		{" & vbLf)
                    tmpS.Append("			if(parseInt(board" & boardSuffix & "[i][2]) == 0)" & vbLf)
                    tmpS.Append("			{" & vbLf)
                    tmpS.Append("               if(sel_color == '') sel_color = '" & AppLogic.GetString("order.cs.16", ThisCustomer.SkinID, ThisCustomer.LocaleSetting) & "';" & vbLf)
                    tmpS.Append("               if(sel_size == '') sel_size = '" & AppLogic.GetString("order.cs.16", ThisCustomer.SkinID, ThisCustomer.LocaleSetting) & "';" & vbLf)
                    tmpS.Append("				alert('" & String.Format(AppLogic.GetString("common.cs.75", SkinID, LocaleSetting), ColorOptionPrompt, SizeOptionPrompt, ColorOptionPrompt, SizeOptionPrompt).Replace("\\n", "\n") & "');" & vbLf)
                    tmpS.Append("			}" & vbLf)
                    tmpS.Append("			else" & vbLf)
                    tmpS.Append("			{" & vbLf)
                    tmpS.Append("               if(sel_color == '') sel_color = '" & AppLogic.GetString("order.cs.16", ThisCustomer.SkinID, ThisCustomer.LocaleSetting) & "';" & vbLf)
                    tmpS.Append("               if(sel_size == '') sel_size = '" & AppLogic.GetString("order.cs.16", ThisCustomer.SkinID, ThisCustomer.LocaleSetting) & "';" & vbLf)
                    tmpS.Append("				alert('" & String.Format(AppLogic.GetString("common.cs.76", SkinID, LocaleSetting), ColorOptionPrompt, SizeOptionPrompt, ColorOptionPrompt, SizeOptionPrompt).Replace("\\n", "\n").Replace("board", "board" & boardSuffix) & "');" & vbLf)
                    tmpS.Append("			}" & vbLf)
                    tmpS.Append("			submitenabled(theForm);" & vbLf)
                    tmpS.Append("			return (false);" & vbLf)
                    tmpS.Append("		}" & vbLf)
                    tmpS.Append("	}" & vbLf)
                    tmpS.Append("}" & vbLf)
                    tmpS.Append("if(sizecolorfound == 0)" & vbLf)
                    tmpS.Append("{" & vbLf)
                    tmpS.Append("   if(sel_color == '') sel_color = '" & AppLogic.GetString("order.cs.16", ThisCustomer.SkinID, ThisCustomer.LocaleSetting) & "';" & vbLf)
                    tmpS.Append("   if(sel_size == '') sel_size = '" & AppLogic.GetString("order.cs.16", ThisCustomer.SkinID, ThisCustomer.LocaleSetting) & "';" & vbLf)
                    tmpS.Append("	alert('" & AppLogic.GetString("shoppingcart.cs.115", ThisCustomer.SkinID, ThisCustomer.LocaleSetting).Replace("'", "").Replace("{0}", "[' + sel_color + ']").Replace("{1}", "[' + sel_size + ']") & "');" & vbLf)
                    tmpS.Append("	submitenabled(theForm);" & vbLf)
                    tmpS.Append("	return (false);" & vbLf)
                    tmpS.Append("}" & vbLf)
                    tmpS.Append("submitenabled(theForm);" & vbLf)
                End If
            End If
            tmpS.Append("	submitenabled(theForm);" & vbLf)
            tmpS.Append("	return (true);" & vbLf)
            tmpS.Append("	}" & vbLf & "//-->" & vbLf)
            tmpS.Append("</script>" & vbLf)


            ' leave empty for now, let's make sure we set it's value when do a postback

            'tmpS.AppendFormat("<input name=\"AddToCart_{0}_{1}\" id=\"AddToCart_{0}_{1}\" type=\"hidden\" value=\"\">", ProductID, VariantID);
            tmpS.AppendFormat("<input name=""VariantStyle_{0}_{1}"" id=""VariantStyle_{0}_{1}"" type=""hidden"" value=""" & (CInt(Fix(VariantStyle))).ToString() & """>", ProductID, VariantID)
            tmpS.AppendFormat("<input name=""IsWishList_{0}_{1}"" id=""IsWishList_{0}_{1}"" type=""hidden"" value=""0"">", ProductID, VariantID)
            tmpS.AppendFormat("<input name=""IsGiftRegistry_{0}_{1}"" id=""IsGiftRegistr_{0}_{1}"" type=""hidden"" value=""0"">", ProductID, VariantID)
            tmpS.AppendFormat("<input type=""hidden"" name=""UpsellProducts_{0}_{1}"" id=""UpsellProducts_{0}_{1}"" value="""" class=""aspdnsf_UpsellProducts"" >" & vbLf, ProductID, VariantID)
            tmpS.AppendFormat("<input type=""hidden"" name=""CartRecID_{0}_{1}"" id=""CartRecID_{0}_{1}"" value=""" & CartRecID.ToString() & """>" & vbLf, ProductID, VariantID)
            tmpS.AppendFormat("<input type=""hidden"" name=""ProductID_{0}_{1}"" id=""ProductID_{0}_{1}"" value=""" & ProductID.ToString() & """>" & vbLf, ProductID, VariantID)
            tmpS.Append("<input type=""hidden"" name=""PackID"" id=""PackID"" value=""" & packID.ToString() & """>" & vbLf)
            If VariantStyle = VariantStyleEnum.RegularVariantsWithAttributes OrElse VariantStyle = VariantStyleEnum.ERPWithRollupAttributes Then
                tmpS.AppendFormat("<input type=""hidden"" name=""VariantID_{0}_{1}"" id=""VariantID_{0}_{1}"" value=""" & VariantID.ToString() & """>" & vbLf, ProductID, VariantID)
            End If
            If forPack Then
                tmpS.AppendFormat("<input type=""hidden"" name=""IsSubmit_{0}_{1}"" id=""IsSubmit_{0}_{1}t"" value=""" & AppLogic.GetString("common.cs.77", SkinID, LocaleSetting) & """>" & vbLf, ProductID, VariantID)
                tmpS.AppendFormat("<input type=""hidden"" name=""ProductTypeID_{0}_{1}"" id=""ProductTypeID_{0}_{1}"" value=""0"">" & vbLf, ProductID, VariantID)
                If ColorsMaster.Length = 0 Then
                    tmpS.AppendFormat("<input type=""hidden"" name=""Color_{0}_{1}"" id=""Color_{0}_{1}"" value="""">" & vbLf, ProductID, VariantID)
                End If
                If SizesMaster.Length = 0 Then
                    tmpS.AppendFormat("<input type=""hidden"" name=""Size_{0}_{1}"" id=""Size_{0}_{1}"" value="""">" & vbLf, ProductID, VariantID)
                End If
            End If
            If AppLogic.AppConfigBool("ShowPreviousPurchase") AndAlso AppLogic.Owns(ProductID, ThisCustomer.CustomerID) Then
                tmpS.Append("<div align=""center"">" & AppLogic.GetString("common.cs.86", SkinID, LocaleSetting) & "</div>")
            End If

            If CustomerEntersPrice Then
                tmpS.Append(CustomerEntersPricePrompt)
                tmpS.Append("&nbsp;")
                tmpS.AppendFormat("<input maxLength=""10"" size=""10"" name=""Price_{0}_{1}"" ID=""Price_{0}_{1}"" value=""" & Localization.CurrencyStringForGatewayWithoutExchangeRate(ProductPriceForEdit) & """>", ProductID, VariantID)
                tmpS.Append("<input type=""hidden"" name=""Price_vldt"" value=""[req][number][blankalert=" & AppLogic.GetString("shoppingcart.cs.113", SkinID, LocaleSetting) & "][invalidalert=" & AppLogic.GetString("shoppingcart.cs.114", SkinID, LocaleSetting) & "]"">" & vbLf)
                tmpS.Append("&nbsp;")
            End If

            If (Not CustomerEntersPrice) AndAlso (AppLogic.AppConfigBool("ShowQuantityOnProductPage") AndAlso (Not forKit)) OrElse ((Not AppLogic.AppConfigBool("HideKitQuantity")) AndAlso forKit) Then
                If RestrictedQuantities.Length = 0 Then
                    Dim InitialQ As Integer = 1
                    If MinimumQuantity > 0 Then
                        InitialQ = MinimumQuantity
                    ElseIf AppLogic.AppConfig("DefaultAddToCartQuantity").Length <> 0 Then
                        InitialQ = AppLogic.AppConfigUSInt("DefaultAddToCartQuantity")
                    End If
                    If QuantityForEdit <> 0 Then
                        InitialQ = QuantityForEdit
                    End If
                    'WSD | 2012.05.09 - Changed styles
                    'tmpS.AppendFormat("<small>" & AppLogic.GetString("common.cs.78", SkinID, LocaleSetting) & "</small> <input type=""text"" value=""" & InitialQ.ToString() & """ name=""Quantity_{0}_{1}"" id=""Quantity_{0}_{1}"" size=""3"" maxlength=""4"">", ProductID, VariantID)
                    tmpS.AppendFormat("<span class=""lg-bold"">" & AppLogic.GetString("common.cs.78", SkinID, LocaleSetting) & "</span> <input type=""text"" value=""" & InitialQ.ToString() & """ name=""Quantity_{0}_{1}"" id=""Quantity_{0}_{1}"" size=""3"" maxlength=""4"">", ProductID, VariantID)
                    tmpS.Append("<input name=""Quantity_vldt"" type=""hidden"" value=""[req][integer][number][blankalert=" & AppLogic.GetString("common.cs.79", SkinID, LocaleSetting) & "][invalidalert=" & AppLogic.GetString("common.cs.80", SkinID, LocaleSetting) & "]"">&nbsp;")
                Else
                    'WSD | 2012.05.09 - Changed styles
                    'tmpS.AppendFormat("<small>" & AppLogic.GetString("common.cs.78", SkinID, LocaleSetting) & "</small>")
                    tmpS.AppendFormat("<span class=""lg-bold"">" & AppLogic.GetString("common.cs.78", SkinID, LocaleSetting) & "</span>")
                    tmpS.AppendFormat("<select name=""Quantity_{0}_{1}"" id=""Quantity_{0}_{1}"" size=""1"">", ProductID, VariantID)
                    For Each s As String In RestrictedQuantities.Split(","c)
                        If s.Trim().Length <> 0 Then
                            Dim Q As Integer = Localization.ParseUSInt(s.Trim())
                            tmpS.Append("<option value=""" & Q.ToString() & """ " & CommonLogic.IIF(QuantityForEdit = Q, " selected ", "") & ">" & Q.ToString() & "</option>")
                        End If
                    Next s
                    tmpS.Append("</select>&nbsp;")
                End If
            Else
                tmpS.AppendFormat("<input name=""Quantity_{0}_{1}"" id=""Quantity_{0}_{1}"" type=""hidden"" value=""1"">", ProductID, VariantID)
            End If
            Dim M As Decimal = 1D
            Dim MM As String = ThisCustomer.CurrencyString(M).Substring(0, 1) ' get currency symbol
            If CommonLogic.IsInteger(MM) Then
                MM = String.Empty ' something international happened, so just leave empty, we only want currency symbol, not any digits
            End If
            If VariantStyle = VariantStyleEnum.RegularVariantsWithAttributes OrElse VariantStyle = VariantStyleEnum.ERPWithRollupAttributes Then
                If SizesMaster.Length <> 0 Then
                    Dim SizesMasterSplit() As String = SizesMaster.Split(","c)
                    Dim SizesDisplaySplit() As String = SizesDisplay.Split(","c)
                    Dim SizeSKUsSplit() As String = SizeSKUModifiers.Split(","c)
                    tmpS.AppendFormat("<select size=""1"" name=""Size_{0}_{1}"" id=""Size_{0}_{1}"" class=""SizeText"" >" & vbLf, ProductID, VariantID)
                    If Not AppLogic.AppConfigBool("AutoSelectFirstSizeColorOption") Then
                        tmpS.Append("<option value=""-,-"">" & SizeOptionPrompt & "</option>" & vbLf)
                    End If
                    For i As Integer = SizesMasterSplit.GetLowerBound(0) To SizesMasterSplit.GetUpperBound(0)
                        Dim SizeString As String = SizesDisplaySplit(i).Trim()
                        Dim SizeStringValue As String = SizeString
                        Dim Modifier As String = String.Empty
                        Try
                            Modifier = SizeSKUsSplit(i)
                        Catch
                        End Try
                        Dim SizePriceDeltaValue As Decimal = AppLogic.GetColorAndSizePriceDelta("", SizesMasterSplit(i).Trim(), TaxClassID, ThisCustomer, True, False)
                        Dim SizePriceDelta As Decimal = AppLogic.GetColorAndSizePriceDelta("", SizesMasterSplit(i).Trim(), TaxClassID, ThisCustomer, True, True)
                        If SizeString.IndexOf("[") <> -1 Then
                            SizeString = SizeString.Substring(0, SizeString.IndexOf("[")).Trim() & " [" & AppLogic.AppConfig("AjaxPricingPrompt") & CommonLogic.IIF(SizePriceDelta > 0, "+", "") & ThisCustomer.CurrencyString(SizePriceDelta) & "]"
                            SizeStringValue = SizeString.Substring(0, SizeString.IndexOf("[")).Trim() & " [" & CommonLogic.IIF(SizePriceDeltaValue > 0, "+", "") & Localization.CurrencyStringForGatewayWithoutExchangeRate(SizePriceDeltaValue) & "]"
                        End If
                        tmpS.Append("<option value=""" & SizesMasterSplit(i) & "," & Modifier & """ " & CommonLogic.IIF(ChosenSizeForEdit = SizeStringValue, " selected ", "") & ">" & HttpContext.Current.Server.HtmlDecode(SizeString) & "</option>" & vbLf)
                    Next i
                    tmpS.Append("</select>" & vbLf)
                End If
                If ColorsMaster.Length <> 0 Then
                    Dim ColorsMasterSplit() As String = ColorsMaster.Split(","c)
                    Dim ColorsDisplaySplit() As String = ColorsDisplay.Split(","c)
                    Dim ColorSKUsSplit() As String = ColorSKUModifiers.Split(","c)
                    tmpS.Append(String.Format("<select size=""1"" id=""Color_{0}_{1}"" name=""Color_{0}_{1}"" onChange=""" & CommonLogic.IIF(ColorChangeProductImage, "setcolorpic_" & ProductID.ToString() & "(this.value);", "") & """ >" & vbLf, ProductID, VariantID))
                    'tmpS.AppendFormat("<select size=\"1\" id=\"Color_{0}_{1}\" name=\"Color_{0}_{1}\" onChange=\"" + CommonLogic.IIF(ColorChangeProductImage, "setcolorpic_" + ProductID.ToString() + "(this.value);", "") + " >\n", ProductID, VariantID);
                    'tmpS.Append(      "<select size=\"1\" id=\"Color\" name=\"Color\" onChange=\"" + CommonLogic.IIF(ColorChangeProductImage, "setcolorpic_" + ProductID.ToString() + "(this.value);", "") + CommonLogic.IIF(HasColorPriceModifiers, "if(typeof(getPricing) == 'function'){getPricing(" + ProductID.ToString() + "," + VariantID.ToString() + ")};", "") + "\">\n");

                    If Not AppLogic.AppConfigBool("AutoSelectFirstSizeColorOption") Then
                        tmpS.Append("<option value=""-,-"">" & ColorOptionPrompt & "</option>" & vbLf)
                    End If
                    For i As Integer = ColorsMasterSplit.GetLowerBound(0) To ColorsMasterSplit.GetUpperBound(0)
                        Dim ColorString As String = ColorsDisplaySplit(i).Trim()
                        Dim ColorStringValue As String = ColorString
                        Dim Modifier As String = String.Empty
                        Try
                            Modifier = ColorSKUsSplit(i)
                        Catch
                        End Try
                        Dim ColorPriceDeltaValue As Decimal = AppLogic.GetColorAndSizePriceDelta(ColorsMasterSplit(i).Trim(), "", TaxClassID, ThisCustomer, True, False)
                        Dim ColorPriceDelta As Decimal = AppLogic.GetColorAndSizePriceDelta(ColorsMasterSplit(i).Trim(), "", TaxClassID, ThisCustomer, True, True)
                        If ColorString.IndexOf("[") <> -1 Then
                            ColorString = ColorString.Substring(0, ColorString.IndexOf("[")).Trim() & " [" & AppLogic.AppConfig("AjaxPricingPrompt") & CommonLogic.IIF(ColorPriceDelta > 0, "+", "") & ThisCustomer.CurrencyString(ColorPriceDelta) & "]"
                            ColorStringValue = ColorString.Substring(0, ColorString.IndexOf("[")).Trim() & " [" & CommonLogic.IIF(ColorPriceDeltaValue > 0, "+", "") & Localization.CurrencyStringForGatewayWithoutExchangeRate(ColorPriceDeltaValue) & "]"
                        End If
                        tmpS.Append("<option value=""" & HttpContext.Current.Server.HtmlEncode(ColorsMasterSplit(i)) & "," & Modifier & """ " & CommonLogic.IIF(ChosenColorForEdit = ColorStringValue, " selected ", "") & ">" & HttpContext.Current.Server.HtmlDecode(ColorString) & "</option>" & vbLf)
                    Next i
                    tmpS.Append("</select>" & vbLf)
                End If
            End If
            If RequiresTextOption OrElse ShowTextOption Then
                tmpS.Append("<br />")
                If TextOptionMaxLength < 50 Then
                    tmpS.AppendFormat(TextOptionPrompt & ": <input type=""text"" size=""20"" maxlength=""" & TextOptionMaxLength.ToString() & """  name=""TextOption_{0}_{1}"" id=""TextOption{0}_{1}"" value=""" & TextOptionForEdit & """>", ProductID, VariantID)
                Else
                    tmpS.AppendFormat(TextOptionPrompt & ":<br/><textarea rows=4 cols=50 name=""TextOption_{0}_{1}"" id=""TextOption{0}_{1}"" onkeypress=""if(this.value.length>=" & TextOptionMaxLength.ToString() & " && ((event.keyCode < 33 || event.keyCode > 40) && event.keyCode != 45 && event.keyCode != 46)) {{return false;}} "">" & TextOptionForEdit & "</textarea>", ProductID, VariantID)
                End If
                tmpS.Append("<br />")
            End If

            Dim showAddToCartButton As Boolean = True
            Dim showAddToWishListButton As Boolean = False
            Dim showAddGiftRegistryButton As Boolean = False

            showAddToCartButton = True

            '**************************
            'WSD - custom
            '**************************
            'If AppLogic.AppConfigBool("AddToCart.UseImageButton") AndAlso AppLogic.AppConfig("AddToCart.AddToCartButton") <> "" Then
            '    ' render image button
            '    Dim src = AppLogic.SkinImage(AppLogic.AppConfig("AddToCart.AddToCartButton"))
            '    tmpS.AppendFormat("<input type=""image"" id=""AddToCartButton_{0}_{1}"" name=""AddToCartButton_{0}_{1}"" class=""AddToCartButton"" src=""{2}"" alt=""{3}"" ", ProductID, VariantID, src, AppLogic.GetString("AppConfig.CartButtonPrompt", SkinID, LocaleSetting))

            '    Dim mouseOverImage = AppLogic.AppConfig("AddToCart.AddToCartButton_MouseOver")
            '    If Not String.IsNullOrEmpty(mouseOverImage) Then
            '        Dim mouseOverSrc = AppLogic.SkinImage(mouseOverImage)
            '        tmpS.AppendFormat("  onmouseover=""this.src = '{0}'"" ", mouseOverSrc)

            '        ' attach the mouseout event automatically to switch back to the original image
            '        tmpS.AppendFormat("  onmouseout=""this.src = '{0}'"" ", src)
            '    End If

            '    Dim mouseDownImage = AppLogic.AppConfig("AddToCart.AddToCartButton_MouseDown")
            '    If Not String.IsNullOrEmpty(mouseDownImage) Then
            '        Dim mouseDownImageSrc = AppLogic.SkinImage(mouseDownImage)
            '        tmpS.AppendFormat("  onmousedown=""this.src = '{0}'"" ", mouseDownImageSrc)
            '    End If

            '    tmpS.AppendFormat(" />")
            'Else
            '    ' render normal html button
            '    tmpS.AppendFormat("<input type=""button"" id=""AddToCartButton_{0}_{1}"" name=""AddToCartButton_{0}_{1}"" class=""AddToCartButton"" value=""{2}"">", ProductID, VariantID, AppLogic.GetString("AppConfig.CartButtonPrompt", SkinID, LocaleSetting))
            'End If


            If AppLogic.AppConfigBool("AddToCart.UseImageButton") AndAlso AppLogic.AppConfig("AddToCart.AddToCartButton") <> "" Then
                Dim src = "/App_Templates/Skin_1/Images/red_addtocart-off.gif"
                tmpS.AppendFormat("<input type=""image"" id=""AddToCartButton_{0}_{1}"" name=""AddToCartButton_{0}_{1}"" src=""{2}"" alt=""{3}"" style=""vertical-align: middle; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-top-style: none; border-right-style: none; border-bottom-style: none; border-left-style: none; border-color: initial; border-image: initial; cursor: pointer;"" ", ProductID, VariantID, src, AppLogic.GetString("AppConfig.CartButtonPrompt", SkinID, LocaleSetting))

                Dim mouseOverSrc = "/App_Templates/Skin_1/Images/red_addtocart-on.gif"
                tmpS.AppendFormat("  onmouseover=""this.src = '{0}'"" ", mouseOverSrc)
                tmpS.AppendFormat("  onmouseout=""this.src = '{0}'"" ", src)

                Dim mouseDownImageSrc = "/App_Templates/Skin_1/Images/red_addtocart-on.gif"
                tmpS.AppendFormat("  onmousedown=""this.src = '{0}'"" ", mouseDownImageSrc)

                tmpS.AppendFormat(" />")
            Else
                tmpS.AppendFormat("<input type=""button"" id=""AddToCartButton_{0}_{1}"" name=""AddToCartButton_{0}_{1}"" value=""{2}"" style=""vertical-align: middle; border-top-width: 0px; border-right-width: 0px; border-bottom-width: 0px; border-left-width: 0px; border-top-style: none; border-right-style: none; border-bottom-style: none; border-left-style: none; border-color: initial; border-image: initial; cursor: pointer;"">", ProductID, VariantID, AppLogic.GetString("AppConfig.CartButtonPrompt", SkinID, LocaleSetting))
            End If
            '**************************
            'WSD - custom
            '**************************


            If AppLogic.AppConfigBool("ShowWishButtons") AndAlso showWishListButton Then
                showAddToWishListButton = True

                tmpS.AppendFormat("&nbsp;")

                If AppLogic.AppConfigBool("AddToCart.UseImageButton") AndAlso AppLogic.AppConfig("AddToCart.AddToWishButton") <> "" Then
                    ' render image button
                    Dim src = AppLogic.SkinImage(AppLogic.AppConfig("AddToCart.AddToWishButton"))
                    tmpS.AppendFormat("<input type=""image"" id=""AddToWishButton_{0}_{1}"" name=""AddToWishButton_{0}_{1}"" class=""AddToWishButton"" src=""{2}"" alt=""{3}"" ", ProductID, VariantID, src, AppLogic.GetString("AppConfig.WishButtonPrompt", SkinID, LocaleSetting))

                    Dim mouseOverImage = AppLogic.AppConfig("AddToCart.AddToWishButton_MouseOver")
                    If Not String.IsNullOrEmpty(mouseOverImage) Then
                        Dim mouseOverSrc = AppLogic.SkinImage(mouseOverImage)
                        tmpS.AppendFormat("  onmouseover=""this.src = '{0}'"" ", mouseOverSrc)

                        ' attach the mouseout event automatically to switch back to the original image
                        tmpS.AppendFormat("  onmouseout=""this.src = '{0}'"" ", src)
                    End If

                    Dim mouseDownImage = AppLogic.AppConfig("AddToCart.AddToWishButton_MouseDown")
                    If Not String.IsNullOrEmpty(mouseDownImage) Then
                        Dim mouseDownImageSrc = AppLogic.SkinImage(mouseDownImage)
                        tmpS.AppendFormat("  onmousedown=""this.src = '{0}'"" ", mouseDownImageSrc)
                    End If
                Else
                    ' Render normal html button
                    tmpS.AppendFormat("<input type=""button"" id=""AddToWishButton_{0}_{1}"" name=""AddToWishButton_{0}_{1}"" class=""AddToWishButton"" value=""" & AppLogic.GetString("AppConfig.WishButtonPrompt", SkinID, LocaleSetting) & """ >", ProductID, VariantID)
                End If
            End If

            ' TBD should we allow "recurring" products to be added to a gift registry?????
            If AppLogic.m_ProductIsML() AndAlso AppLogic.ProductIsMLExpress() = False Then
                If AppLogic.AppConfigBool("ShowGiftRegistryButtons") AndAlso showGiftRegistryButton AndAlso (Not IsRecurring) AndAlso (Not IsDownload) Then
                    showAddGiftRegistryButton = True

                    tmpS.AppendFormat("&nbsp;")

                    If AppLogic.AppConfigBool("AddToCart.UseImageButton") AndAlso AppLogic.AppConfig("AddToCart.AddToGiftRegistryButton") <> "" Then
                        ' render image button
                        Dim src = AppLogic.SkinImage(AppLogic.AppConfig("AddToCart.AddToGiftRegistryButton"))
                        tmpS.AppendFormat("<input type=""image"" id=""AddToGiftButton_{0}_{1}"" name=""AddToGiftButton_{0}_{1}"" class=""AddToGiftButton"" src=""{2}"" alt=""{3}"" ", ProductID, VariantID, src, AppLogic.GetString("AppConfig.GiftButtonPrompt", SkinID, LocaleSetting))

                        Dim mouseOverImage = AppLogic.AppConfig("AddToCart.AddToGiftRegistryButton_MouseOver")
                        If Not String.IsNullOrEmpty(mouseOverImage) Then
                            Dim mouseOverSrc = AppLogic.SkinImage(mouseOverImage)
                            tmpS.AppendFormat("  onmouseover=""this.src = '{0}'"" ", mouseOverSrc)

                            ' attach the mouseout event automatically to switch back to the original image
                            tmpS.AppendFormat("  onmouseout=""this.src = '{0}'"" ", src)
                        End If

                        Dim mouseDownImage = AppLogic.AppConfig("AddToCart.AddToGiftRegistryButton_MouseDown")
                        If Not String.IsNullOrEmpty(mouseDownImage) Then
                            Dim mouseDownImageSrc = AppLogic.SkinImage(mouseDownImage)
                            tmpS.AppendFormat("  onmousedown=""this.src = '{0}'"" ", mouseDownImageSrc)
                        End If
                    Else
                        ' render normal html button
                        tmpS.AppendFormat("<input type=""button"" id=""AddToGiftButton_{0}_{1}"" class=""AddToGiftButton"" value=""" & AppLogic.GetString("AppConfig.GiftButtonPrompt", SkinID, LocaleSetting) & """ >", ProductID, VariantID)
                    End If
                End If
            End If

            If DisplayFormat = 5 Then
                tmpS.Append("<img src=""images/spacer.gif"" width=""20"" height=""1"">" & vbLf)
            End If

            tmpS.Append("</div>")

            tmpS.AppendLine()
            ' For the move to using masterpages, the  primary prerequisite was to have the form on the master template
            ' we therefore stripped this extension of it's own form tag
            ' we resort to using javascript to do that
            tmpS.Append("<script type=""text/javascript"" language=""Javascript"" >" & vbLf)
            ' attach a delegate function that get's called on browser DOM load            
            tmpS.Append("    $window_addLoad(function(){ " & vbLf)

            ' also defined here is the delAtcx function
            ' which is used on the addto-x button's onclick handler
            ' this function will then call the __doPostBack function which is an asp.net standard javascript function
            ' which has the following signature:
            '          __doPostBack(eventTarget, eventArgument) 
            ' To simulate same-page postback through javascript
            ' we use the "AddToCart" as the eventTarget, which we'll try to interpret as a command later during postback
            ' and the the cartType, productid and variantid concantenated as the eventArgument
            ' this cause the current page(showproduct.aspx) to postback to itself
            ' which we will then try to interpret as addtocart postback 
            ' via the __EVENTTARGET and __EVENTARGUMENT form values....


            tmpS.AppendFormat("        var ctrl_{0} = new aspdnsf.Controls.AddToCartForm({1}, {2}); " & vbLf, FormName, ProductID, VariantID)
            tmpS.AppendFormat("        ctrl_{0}.setValidationRoutine( function(){{ return {0}_Validator(theForm) }} );" & vbLf, FormName)

            Dim useAjaxBehavior As Boolean = AppLogic.AppConfigBool("Minicart.UseAjaxAddToCart") AndAlso Not ThisCustomer.IsImpersonated
            If forKit OrElse forPack Then
                ' ajax addtocart is not supported for kits and packs
                useAjaxBehavior = False
            End If

            tmpS.AppendFormat("        ctrl_{0}.setUseAjaxBehavior({1});" & vbLf, FormName, useAjaxBehavior.ToString().ToLowerInvariant())

            If showAddToCartButton Then
                tmpS.AppendFormat("        ctrl_{0}.registerButton('AddToCartButton_{1}_{2}', {3});" & vbLf, FormName, ProductID, VariantID, CInt(CartTypeEnum.ShoppingCart))
            End If
            If showAddToWishListButton Then
                tmpS.AppendFormat("        ctrl_{0}.registerButton('AddToWishButton_{1}_{2}', {3});" & vbLf, FormName, ProductID, VariantID, CInt(CartTypeEnum.WishCart))
            End If
            If showAddGiftRegistryButton Then
                tmpS.AppendFormat("        ctrl_{0}.registerButton('AddToGiftButton_{1}_{2}', {3});" & vbLf, FormName, ProductID, VariantID, CInt(CartTypeEnum.GiftRegistryCart))
            End If

            tmpS.Append("    });")
            tmpS.Append("</script>")
            tmpS.AppendLine()

            If (Not AppLogic.AppConfigBool("BuySafe.DisableAddoToCartKicker")) AndAlso AppLogic.GlobalConfigBool("BuySafe.Enabled") AndAlso AppLogic.GlobalConfig("BuySafe.Hash").Length <> 0 Then
                tmpS.AppendLine("<div class=""BuySafeKicker"" id=""ProductBuySafeKicker"">")
                tmpS.AppendLine("<span id=""buySAFE_Kicker"" name=""buySAFE_Kicker"" type=""" & AppLogic.AppConfig("BuySafe.KickerType") & """></span>")
                tmpS.AppendLine("</div>")
            End If

            Result = tmpS.ToString()
        Catch ex As Exception
            wPostError(ex.ToString, "wGetAddToCartForm", "app")
        End Try

        Return Result
    End Function


    'Global Functions
    Private Function wGetCustomerLevelID() As Integer
        Dim Result As Integer = 0

        Try
            Result = ThisCustomer.CustomerLevelID

            If Not (ThisCustomer.HasCustomerRecord) And CommonLogic.CookieCanBeDangerousContent("PriceProgram", False) = m_CsePricingProgram Then
                Result = m_CseCustomerLevelID
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetCustomerLevelID", "app")
        End Try

        'Debug
        'Result = 115

        Return Result
    End Function

    Private Function wLookupProductImage(ByVal ProductID As Integer, ByVal ImageFileNameOverride As String, ByVal SkuSuffix As String, ByVal Product As String, ByVal DesiredSize As String) As String
        Dim Result As String = String.Empty

        Try
            Dim Filename As String = String.Empty

            Dim PicSm As String = String.Empty
            Dim PicMd As String = String.Empty
            Dim PicLg As String = String.Empty

            If Len(ImageFileNameOverride) > 0 Then
                Filename = ImageFileNameOverride
            Else
                Filename = ProductID.ToString & ".jpg"
            End If

            If Not FileExists(m_ProductImagePath & "Icon\" & Filename) Then
                PicSm = m_ProductImageUrl & "NoPicSm.jpg"
            Else
                PicSm = m_ProductImageUrl & "Icon/" & Filename
            End If

            If Not FileExists(m_ProductImagePath & "Medium\" & Filename) Then
                PicMd = m_ProductImageUrl & "NoPicSm.jpg"
            Else
                PicMd = m_ProductImageUrl & "Medium/" & Filename
            End If

            If Not FileExists(m_ProductImagePath & "Large\" & Filename) Then
                PicLg = String.Empty
            Else
                PicLg = m_ProductImageUrl & "Large/" & Filename
            End If

            If LCase(DesiredSize) = "icon" Then
                Result = "<img src=""" & PicSm & """ alt=""" & HtmlEncode(Product) & """ width=""90"" height=""90"" />"
            ElseIf LCase(DesiredSize) = "mini" Then
                Result = "<img src=""" & PicSm & """ alt=""" & HtmlEncode(Product) & """ width=""50"" height=""50"" />"
            ElseIf LCase(DesiredSize) = "special" Then
                Result = "<img src=""" & PicSm & """ alt=""" & HtmlEncode(Product) & """ width=""100"" height=""100"" />"
            Else
                Dim sb As New StringBuilder(4096)

                If Len(PicLg) > 0 Then
                    sb.Append("<a rel=""lightbox"" href=""" & PicLg & """ title=""" & HtmlEncode(Product) & """><img src=""" & PicMd & """ alt=""" & HtmlEncode(Product) & """ /></a>")
                    'sb.Append("<div id=""productPurchaseLinks""><a rel=""lightbox"" href=""" & PicLg & """ title=""" & Product & """><img src=""/App_Templates/skin_1/images/showlarger.gif"" alt=""" & Product & """ /></a></div>")
                    sb.Append("<div id=""productPurchaseLinks"">")
                    sb.Append("<a rel=""lightbox"" href=""" & PicLg & """ title=""" & HtmlEncode(Product) & """>Zoom Image</a>" & wGetTreepodiaVideo(SkuSuffix, Product, "y") & "")
                    sb.Append("</div>")
                Else
                    sb.Append("<img src=""" & PicMd & """ alt=""" & HtmlEncode(Product) & """ />")
                    sb.Append("<div id=""productPurchaseLinks"">")
                    sb.Append("" & wGetTreepodiaVideo(SkuSuffix, Product, "n") & "")
                    sb.Append("</div>")
                End If

                Result = sb.ToString
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wLookupProductImage", "app")
        End Try

        Return Result
    End Function

    Public Function wGetTreepodiaVideo(ByVal Sku As String, ByVal Title As String, ByVal ShowPipe As String) As String
        Dim Result As String = String.Empty

        Try
            If Title.Length > 0 Then
                Title = Replace(Title, """", "")
            End If

            Result += "" & vbCrLf
            Result += "<script type=""text/javascript"">" & vbCrLf
            Result += "	var trpdSKU = '" & Sku & "';" & vbCrLf
            Result += "	var video; var product;" & vbCrLf
            Result += "	function initTreepodia() { product = Treepodia.getProduct('UA-CLEANITSUPPLY', trpdSKU);product.requestVideo(handleVideo); }" & vbCrLf
            Result += "	function handleVideo(vid) { video = vid;" & vbCrLf
            Result += "	if(vid.hasVideos()) { video.setPlayer(""default""); video.setChromeless(false); video.setAllowFullScreen(false); video.setLoop(false); video.setAutoplay(false); video.setMute(false); document.getElementById('video-btn').style.display = 'inline'; } }" & vbCrLf
            Result += "</script>" & vbCrLf

            Result += "<script type=""text/javascript"">" & vbCrLf
            Result += "	document.write(unescape(""%3Cscript src='"" + document.location.protocol + ""//api.treepodia.com/utils/cb-dialog-white.js' type='text/javascript'%3E%3C/script%3E""));" & vbCrLf
            Result += "</script>" & vbCrLf

            Result += "<script type=""text/javascript"">" & vbCrLf
            Result += "	document.write(unescape(""%3Cscript src='"" + document.location.protocol + ""//api.treepodia.com/video/Treepodia.js' type='text/javascript'%3E%3C/script%3E""));" & vbCrLf
            Result += "</script>" & vbCrLf


            Result += "<div id=""video-btn"" style=""display:none;"">" & vbCrLf
            If ShowPipe = "y" Then
                Result += "&#160;|&#160;"
            End If
            Result += "<a href=""javascript:showVideoDialog('" & Title & "', video)"">Play Video</a>" & vbCrLf
            Result += "</div>" & vbCrLf

            Result += "<noscript>" & vbCrLf
            Result += "<object type=""application/x-shockwave-flash"" data=""http://api.treepodia.com/video/treepodia_player.swf"" width=""640px"" height=""400px"" title=""product video player"" rel=""media:video"">" & vbCrLf
            Result += " <param name=""src"" value=""http://api.treepodia.com/video/treepodia_player.swf""/>" & vbCrLf
            Result += " <param name=""flashvars"" value=""video=http://api.treepodia.com/video/get/UA-CLEANITSUPPLY/" & Sku & "&amp;backcolor=0x000000&amp;frontcolor=0xCCCCCC&amp;lightcolor=0x557722&amp;allowfullscreen=false&amp;auto-play=false&amp;ShowLogo=1&amp;play_on_click=false"" />" & vbCrLf
            Result += "</object>" & vbCrLf
            Result += "</noscript>" & vbCrLf
        Catch ex As Exception
            wPostError(ex.ToString, "wGetTreepodiaHeader", "app")
            Result = ex.ToString
        End Try

        Return Result
    End Function


    Public Function wGetCartDisplay() As String
        Dim Result As String = String.Empty

        Try
            If Not (ShoppingCart.CartIsEmpty(ThisCustomer.CustomerID, CartTypeEnum.ShoppingCart)) Then
                Dim Qry As String = String.Empty

                Qry += " SELECT "
                Qry += "    sc.VariantID, "
                Qry += "    sc.Quantity, "
                Qry += "	ISNULL(pv.Price,0) AS Price, "
                Qry += "	ISNULL(pv.SalePrice,0) AS SalePrice, "
                Qry += "	ISNULL(ep.Price,0) AS ExtendedPrice "
                Qry += " FROM Product p "
                Qry += "    INNER JOIN ProductVariant pv ON p.ProductID = pv.ProductID "
                Qry += "    INNER JOIN ShoppingCart sc ON p.ProductID = sc.ProductID "
                Qry += "    LEFT OUTER JOIN ExtendedPrice ep ON pv.VariantID = ep.VariantID AND ep.CustomerLevelID = " & ThisCustomer.CustomerLevelID.ToString & " "
                Qry += " WHERE sc.CustomerID = " & ThisCustomer.CustomerID.ToString & " "
                Qry += "    AND p.Published = 1 "
                Qry += "    AND p.Deleted = 0 "
                Qry += "    AND pv.Published = 1 "
                Qry += "    AND pv.Deleted = 0 "

                Dim dt As DataTable = wGetDt(Qry)

                If dt.Rows.Count > 0 Then
                    Dim sb As New StringBuilder()

                    Dim VariantID As Integer = 0
                    Dim Price As Decimal = Decimal.Zero
                    Dim SalePrice As Decimal = Decimal.Zero
                    Dim ExtendedPrice As Decimal = Decimal.Zero
                    Dim Quantity As Integer = 0
                    Dim FinalPrice As Decimal = Decimal.Zero

                    Dim CartQuantity As Integer = 0
                    Dim CartTotal As Decimal = Decimal.Zero

                    For Each dr In dt.Rows
                        VariantID = wGetInt(dr("VariantID"))
                        Price = wGetDec(dr("Price"))
                        SalePrice = wGetDec(dr("SalePrice"))
                        ExtendedPrice = wGetDec(dr("ExtendedPrice"))
                        Quantity = wGetInt(dr("Quantity"))

                        FinalPrice = wDetermineLevelPrice(VariantID, wGetCustomerLevelID(), Price, SalePrice, ExtendedPrice)

                        CartQuantity += Quantity
                        CartTotal += FinalPrice * Quantity
                    Next

                    sb.Append("<div class=""right-box nopad rb-border"" style=""height:53px;"">")
                    sb.Append("<table border=""0"" cellpadding=""0"" cellspacing=""0"" style=""width:165px;"">")
                    sb.Append("<tr>")
                    sb.Append("<td style=""width:50px; text-align:center;""><img src=""/App_Templates/Skin_1/Images/cart_icon.gif"" border="""" alt="""" /></td>")
                    sb.Append("<td style=""width:115px; text-align:center;"">Items (" & CartQuantity.ToString & ") " & FormatCurrency(CartTotal) & "<br /><a href=""/shoppingcart.aspx"" class=""minicart"">CHECKOUT</a></td>")
                    sb.Append("</tr>")
                    sb.Append("</table>")
                    sb.Append("</div>")

                    Result = sb.ToString

                    sb.Length = 0
                    sb = Nothing
                End If
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetCartDisplay", "app")
        End Try

        Return Result
    End Function

    Public Shared Function wListrakAbandon_Cart(ByVal ThisCustomer As Customer) As String
        Dim Result As String = String.Empty

        Try
            'List of US State/Territories for Bongo
            Dim StateList As List(Of Integer) = New List(Of Integer)

            StateList.Add(2)
            StateList.Add(3)
            StateList.Add(4)
            StateList.Add(5)
            StateList.Add(6)
            StateList.Add(14)
            StateList.Add(17)
            StateList.Add(18)
            StateList.Add(27)
            StateList.Add(35)
            StateList.Add(47)
            StateList.Add(49)
            StateList.Add(57)

            Dim Cart As ShoppingCart = New ShoppingCart(1, ThisCustomer, CartTypeEnum.ShoppingCart, 0, False)

            Result += "<!-- Listrak Shopping Cart Abandonment -->" & vbCrLf
            Result += "<script type=""text/javascript"">" & vbCrLf
            Result += "    _ltk.SCA.Stage = 1;" & vbCrLf

            'If international checkout (Bongo) don't populate cartitems - don't want sca program for international right now
            If Not ((ThisCustomer.PrimaryShippingAddress.CountryID <> 1) Or (ThisCustomer.PrimaryShippingAddress.CountryID = 1 And StateList.Contains(ThisCustomer.PrimaryShippingAddress.StateID))) Then
                For Each c As CartItem In Cart.CartItems
                    Result += "    _ltk.SCA.AddItemWithLinks('" & c.SKU.ToString & "', " & c.Quantity.ToString & ", '" & Math.Round(c.Price, 2).ToString & "', '" & c.ProductName.ToString & "', '" & c.ProductPicURL.ToString & "', '" & SE.MakeProductLink(c.ProductID, "").ToString & "'); " & vbCrLf
                Next
            End If

            Result += "    _ltk.SCA.Submit();" & vbCrLf
            Result += "</script>" & vbCrLf
            Result += "<!-- Listrak Shopping Cart Abandonment -->" & vbCrLf
        Catch ex As Exception
            wPostError(ex.ToString, "wListrakAbandon_Cart", "app")
        End Try

        Return Result
    End Function

    Public Shared Function wListrakAbandon_Checkout(ByVal ThisCustomer As Customer, ByVal CheckoutStep As String) As String
        Dim Result As String = String.Empty

        Try
            Dim Cart As ShoppingCart = New ShoppingCart(1, ThisCustomer, CartTypeEnum.ShoppingCart, 0, False)

            Result += "<!-- Listrak Shopping Cart Abandonment -->" & vbCrLf
            Result += "<script type=""text/javascript"">" & vbCrLf

            If CheckoutStep = "2" Then
                Result += "   _ltk.SCA.CaptureEmail('ctl00_PageContent_ctrlAccount_txtEmail'); " & vbCrLf
            End If

            Result += "    _ltk.SCA.Stage = " & CheckoutStep & ";" & vbCrLf
            Result += "    _ltk.SCA.SetCustomer('" & ThisCustomer.EMail & "', '" & ThisCustomer.FirstName & "', '" & ThisCustomer.LastName & "');"
            'Result += "    _ltk.SCA.Total = '" & Math.Round(Cart.Total(True), 2) & "'; "
            Result += "    _ltk.SCA.Submit();" & vbCrLf
            Result += "</script>" & vbCrLf
            Result += "<!-- Listrak Shopping Cart Abandonment -->" & vbCrLf
        Catch ex As Exception
            wPostError(ex.ToString, "wListrakAbandon_Checkout", "app")
        End Try

        Return Result
    End Function


    Public Shared Function wGoogleAds_Retarget(ByVal CheckoutStep As String) As String
        Dim Result As String = String.Empty

        Select Case CheckoutStep
            Case "create"
                Result += "<!-- Google Code for Create Account Remarketing List -->" & vbCrLf
                Result += "<script type=""text/javascript"">" & vbCrLf
                Result += "/* <![CDATA[ */" & vbCrLf
                Result += "var google_conversion_id = 1071232004;" & vbCrLf
                Result += "var google_conversion_language = ""en"";" & vbCrLf
                Result += "var google_conversion_format = ""3"";" & vbCrLf
                Result += "var google_conversion_color = ""ffffff"";" & vbCrLf
                Result += "var google_conversion_label = ""2A9jCJK_8wIQhOjm_gM"";" & vbCrLf
                Result += "var google_conversion_value = 0;" & vbCrLf
                Result += "/* ]]> */" & vbCrLf
                Result += "</script>" & vbCrLf
                Result += "<script type=""text/javascript"" src=""https://www.googleadservices.com/pagead/conversion.js"">" & vbCrLf
                Result += "</script>" & vbCrLf
                Result += "<noscript>" & vbCrLf
                Result += "<div style=""display:inline;"">" & vbCrLf
                Result += "<img height=""1"" width=""1"" style=""border-style:none;"" alt="""" src=""https://www.googleadservices.com/pagead/conversion/1071232004/?label=2A9jCJK_8wIQhOjm_gM&amp;guid=ON&amp;script=0""/>" & vbCrLf
                Result += "</div>" & vbCrLf
                Result += "</noscript>" & vbCrLf
            Case "cart"
                Result += "<!-- Google Code for Shopping Cart Remarketing List -->" & vbCrLf
                Result += "<script type=""text/javascript"">" & vbCrLf
                Result += "/* <![CDATA[ */" & vbCrLf
                Result += "var google_conversion_id = 1071232004;" & vbCrLf
                Result += "var google_conversion_language = ""en"";" & vbCrLf
                Result += "var google_conversion_format = ""3"";" & vbCrLf
                Result += "var google_conversion_color = ""ffffff"";" & vbCrLf
                Result += "var google_conversion_label = ""YnLTCJq-8wIQhOjm_gM"";" & vbCrLf
                Result += "var google_conversion_value = 0;" & vbCrLf
                Result += "/* ]]> */" & vbCrLf
                Result += "</script>" & vbCrLf
                Result += "<script type=""text/javascript"" src=""https://www.googleadservices.com/pagead/conversion.js"">" & vbCrLf
                Result += "</script>" & vbCrLf
                Result += "<noscript>" & vbCrLf
                Result += "<div style=""display:inline;"">" & vbCrLf
                Result += "<img height=""1"" width=""1"" style=""border-style:none;"" alt="""" src=""https://www.googleadservices.com/pagead/conversion/1071232004/?label=YnLTCJq-8wIQhOjm_gM&amp;guid=ON&amp;script=0""/>" & vbCrLf
                Result += "</div>" & vbCrLf
                Result += "</noscript>" & vbCrLf
            Case "payment"
                Result += "<!-- Google Code for Billing/Shipping Page Remarketing List -->" & vbCrLf
                Result += "<script type=""text/javascript"">" & vbCrLf
                Result += "/* <![CDATA[ */" & vbCrLf
                Result += "var google_conversion_id = 1071232004;" & vbCrLf
                Result += "var google_conversion_language = ""en"";" & vbCrLf
                Result += "var google_conversion_format = ""3"";" & vbCrLf
                Result += "var google_conversion_color = ""ffffff"";" & vbCrLf
                Result += "var google_conversion_label = ""Vj9FCIrA8wIQhOjm_gM"";" & vbCrLf
                Result += "var google_conversion_value = 0;" & vbCrLf
                Result += "/* ]]> */" & vbCrLf
                Result += "</script>" & vbCrLf
                Result += "<script type=""text/javascript"" src=""https://www.googleadservices.com/pagead/conversion.js"">" & vbCrLf
                Result += "</script>" & vbCrLf
                Result += "<noscript>" & vbCrLf
                Result += "<div style=""display:inline;"">" & vbCrLf
                Result += "<img height=""1"" width=""1"" style=""border-style:none;"" alt="""" src=""https://www.googleadservices.com/pagead/conversion/1071232004/?label=Vj9FCIrA8wIQhOjm_gM&amp;guid=ON&amp;script=0""/>" & vbCrLf
                Result += "</div>" & vbCrLf
                Result += "</noscript>" & vbCrLf
        End Select

        Return Result
    End Function


    Public Function wGetReceiptSummary(ByVal OrderNumber As Integer) As String
        Dim Result As String = String.Empty

        Try
            Dim PrdTot As Decimal = 0D
            Dim DisTot As Decimal = 0D
            Dim BuyTot As Decimal = 0D
            Dim SubTot As Decimal = 0D
            Dim TaxTot As Decimal = 0D
            Dim ShpTot As Decimal = 0D
            Dim OrdTot As Decimal = 0D

            Dim CouponCode As String = String.Empty
            Dim ShippingMethod As String = String.Empty
            Dim ShippingState As String = String.Empty
            Dim TaxRate As String = String.Empty
            Dim ShowBuySafe As Boolean = False

            Dim Qry As String = String.Empty
            Qry += " SELECT OrderShippingCosts ShpTot,OrderTax TaxTot,OrderSubtotal SubTot,OrderTotal OrdTot, "
            Qry += " ROUND((SELECT SUM(OrderedProductPrice) FROM Orders_ShoppingCart WHERE OrderNumber=" & OrderNumber.ToString & "),2) AS PrdTot, "
            Qry += "(SELECT TaxRate FROM StateTaxRate st INNER JOIN State s ON st.StateID=s.StateID WHERE s.Abbreviation=Orders.ShippingState AND st.TaxClassID=1) AS TaxRate,"
            Qry += " OrderOptions,ShippingMethod,CouponCode,ShippingState "
            Qry += " FROM Orders WITH (NOLOCK) WHERE OrderNumber = " & OrderNumber.ToString & " "

            Using con As New SqlConnection(DB.GetDBConn())
                con.Open()
                Using rs As IDataReader = DB.GetRS(Qry, con)
                    If rs.Read() Then
                        PrdTot = Math.Round(wGetDec(DB.RSFieldDecimal(rs, "PrdTot")), 2)
                        SubTot = Math.Round(wGetDec(DB.RSFieldDecimal(rs, "SubTot")), 2)
                        TaxTot = Math.Round(wGetDec(DB.RSFieldDecimal(rs, "TaxTot")), 2)
                        ShpTot = Math.Round(wGetDec(DB.RSFieldDecimal(rs, "ShpTot")), 2)
                        OrdTot = Math.Round(wGetDec(DB.RSFieldDecimal(rs, "OrdTot")), 2)

                        CouponCode = DB.RSField(rs, "CouponCode")
                        TaxRate = Math.Round(DB.RSFieldDecimal(rs, "TaxRate"), 2).ToString & "%"

                        If DB.RSField(rs, "OrderOptions").Length > 0 Then
                            For Each s As String In DB.RSField(rs, "OrderOptions").Split("^"c)
                                Dim flds() As String = s.Split("|"c)

                                If flds(2) = "buySAFE" Then
                                    ShowBuySafe = True
                                    BuyTot = Math.Round(wGetDec(flds(3)), 2)
                                End If
                            Next
                        End If

                        If DB.RSField(rs, "ShippingMethod").Length > 0 Then
                            Dim s() As String = DB.RSField(rs, "ShippingMethod").Split("|"c)
                            ShippingMethod = s(0).ToString
                        End If

                    End If
                End Using
            End Using

            Using con As New SqlConnection(DB.GetDBConn())
                con.Open()
                Using rs As IDataReader = DB.GetRS(Qry, con)
                    If rs.Read() Then
                    End If
                End Using
            End Using

            DisTot = SubTot - PrdTot - BuyTot

            Dim results As New StringBuilder("")

            If ShowBuySafe = True Then
                results.Append("<table width=""100%"">")
                results.Append("<tr>")
                results.Append("<td align=""right"" valign=""top"" width=""100%"">")
                results.Append("<img src=""https://www.cleanitsupply.com/App_Templates/Skin_1/Images/BuySafe_Bonded.GIF"" border=""0"" />")
                results.Append("</td>")
                results.Append("<td align=""right"" valign=""middle"">")
                results.Append("" & FormatCurrency(BuyTot.ToString) & "")
                results.Append("</td>")
                results.Append("</tr>")
                results.Append("</table>")
            End If

            results.Append("<table width=""100%"">")
            results.Append("<tr>")
            results.Append("<td align=""right"" valign=""top"" width=""100%""><b>Product Total</b>:</td>")
            results.Append("<td align=""right"" valign=""top"">" & FormatCurrency((PrdTot + BuyTot).ToString) & "</td>")
            results.Append("</tr><tr>")
            If CouponCode.Length > 0 Then
                results.Append("<td align=""right"" valign=""top"" width=""100%""><b>Discount</b> (" & CouponCode & "):</td>")
                results.Append("<td align=""right"" valign=""top"">" & FormatCurrency(DisTot.ToString) & "</td>")
                results.Append("</tr><tr>")
            End If
            results.Append("<td align=""right"" valign=""top"" width=""100%""><b>Shipping</b> (" & ShippingMethod & "):</td>")
            results.Append("<td align=""right"" valign=""top"">" & FormatCurrency(ShpTot.ToString) & "</td>")
            results.Append("</tr><tr>")
            results.Append("<td align=""right"" valign=""top"" width=""100%""><b>Tax</b> (" & TaxRate & "):</td>")
            results.Append("<td align=""right"" valign=""top"">" & FormatCurrency(TaxTot.ToString) & "</td>")
            results.Append("</tr><tr>")
            results.Append("<td align=""right"" valign=""top"" width=""100%""><b>Total</b>:</td>")
            results.Append("<td align=""right"" valign=""top"">" & FormatCurrency(OrdTot.ToString) & "</td>")
            results.Append("</tr>")
            results.Append("</table>")

            Result = results.ToString
        Catch ex As Exception
            wPostError(ex.ToString, "wGetReceiptSummary", "app")
        End Try

        Return Result
    End Function

    Public Function wGetReceiptDetail(ByVal OrderNumber As Integer) As String
        Dim Result As String = String.Empty

        Try
            Dim Qry As String = String.Empty
            Qry += " SELECT OrderedProductPrice/Quantity AS FinalPrice, * FROM Orders_ShoppingCart WITH (NOLOCK) WHERE OrderNumber = " & OrderNumber.ToString & " "

            Dim results As New StringBuilder("")

            Using con As New SqlConnection(DB.GetDBConn())
                con.Open()
                Using rs As IDataReader = DB.GetRS(Qry, con)
                    While rs.Read()

                        Dim BgClr As String = "#ffffff"

                        Select Case DB.RSFieldInt(rs, "DistributorID")
                            Case 1
                                BgClr = "#FFFFFF"
                            Case 2
                                BgClr = "#CCFFCC"
                            Case 3
                                BgClr = "#FFFFCC"
                            Case 27
                                BgClr = "#DDFAFF"
                            Case Else
                                BgClr = "#FFFFFF"
                        End Select

                        Dim OrderedProductPrice As Decimal = Math.Round(wGetDec(DB.RSFieldDecimal(rs, "OrderedProductPrice")), 2)
                        Dim OrderedProductExtendedPrice As Decimal = Math.Round(wGetDec(DB.RSFieldDecimal(rs, "OrderedProductExtendedPrice")), 2)
                        Dim OrderedProductSalePrice As Decimal = Math.Round(wGetDec(DB.RSFieldDecimal(rs, "OrderedProductSalePrice")), 2)
                        Dim OrderedProductRegularPrice As Decimal = Math.Round(wGetDec(DB.RSFieldDecimal(rs, "OrderedProductRegularPrice")), 2)

                        results.Append("<tr><td colspan=""4""><hr style=""height: 1px; width:100%; color: #DDDDDD;""></td></tr>" & vbCrLf)
                        results.Append("<tr style=""background-color: " & BgClr & """>" & vbCrLf)
                        results.Append("  <td align=""left"" valign=""top""><b>" & DB.RSField(rs, "OrderedProductName") & "</b><br>SKU: " & DB.RSField(rs, "OrderedProductSKU") & "</td>" & vbCrLf)
                        results.Append("  <td align=""center"" valign=""top"">" & DB.RSFieldInt(rs, "Quantity").ToString & "</td>" & vbCrLf)

                        If OrderedProductExtendedPrice > 0 Then
                            results.Append("  <td align=""center"" valign=""top"">" & FormatCurrency(OrderedProductExtendedPrice.ToString) & "</td>" & vbCrLf)
                        ElseIf OrderedProductExtendedPrice = 0 And OrderedProductSalePrice > 0 And OrderedProductSalePrice < OrderedProductRegularPrice Then
                            results.Append("  <td align=""center"" valign=""top"">" & FormatCurrency(OrderedProductSalePrice.ToString) & "</td>" & vbCrLf)
                        Else
                            results.Append("  <td align=""center"" valign=""top"">" & FormatCurrency(OrderedProductRegularPrice.ToString) & "</td>" & vbCrLf)
                        End If

                        results.Append("  <td align=""right"" valign=""top"">" & FormatCurrency(OrderedProductPrice.ToString) & "</td>" & vbCrLf)
                        results.Append("</tr>" & vbCrLf)
                        results.Append("<tr><td colspan=""4""></td></tr>" & vbCrLf)

                    End While
                End Using
            End Using

            Result = results.ToString
        Catch ex As Exception
            wPostError(ex.ToString, "wGetReceiptDetail", "app")
        End Try

        Return Result
    End Function

    Public Shared Function wGetRates(ByVal wCartItems As CartItemCollection, ByVal wCustomer As Customer) As ShippingMethods
        Dim Fnl_Methods As ShippingMethods = New ShippingMethods

        Try
            'List of US State/Territories for Bongo
            Dim StateList As List(Of Integer) = New List(Of Integer)

            StateList.Add(2)
            StateList.Add(3)
            StateList.Add(4)
            StateList.Add(5)
            StateList.Add(6)
            StateList.Add(14)
            StateList.Add(17)
            StateList.Add(18)
            StateList.Add(27)
            StateList.Add(35)
            StateList.Add(47)
            StateList.Add(49)
            StateList.Add(57)

            If wCartItems.Count > 0 Then
                Dim drP As DataRow
                Dim dtPrd As DataTable = New DataTable
                dtPrd.Columns.Add("DistributorID", System.Type.GetType("System.Int32"))
                dtPrd.Columns.Add("ProductID", System.Type.GetType("System.Int32"))
                dtPrd.Columns.Add("Weight", System.Type.GetType("System.Double"))
                dtPrd.Columns.Add("Quantity", System.Type.GetType("System.Double"))
                dtPrd.Columns.Add("Price", System.Type.GetType("System.Double"))
                dtPrd.Columns.Add("TotWeight", System.Type.GetType("System.Double"))
                dtPrd.Columns.Add("TotPrice", System.Type.GetType("System.Double"))
                dtPrd.Columns.Add("wIsLtl", System.Type.GetType("System.Int32"))
                dtPrd.Columns.Add("wUnit", System.Type.GetType("System.String"))
                dtPrd.Columns.Add("wShipSep", System.Type.GetType("System.Int32"))
                dtPrd.Columns.Add("wShipFree", System.Type.GetType("System.Int32"))
                dtPrd.AcceptChanges()

                Dim drD As DataRow
                Dim dtDst As DataTable = New DataTable
                dtDst.Columns.Add("DistributorID", System.Type.GetType("System.Int32"))
                dtDst.Columns.Add("Name", System.Type.GetType("System.String"))
                dtDst.Columns.Add("ShipWeight", System.Type.GetType("System.Double"))
                dtDst.Columns.Add("ShipValue", System.Type.GetType("System.Double"))
                dtDst.Columns.Add("ShipCost", System.Type.GetType("System.Double"))
                dtDst.Columns.Add("ShipIsLtl", System.Type.GetType("System.Int32"))
                dtDst.Columns.Add("OrgCity", System.Type.GetType("System.String"))
                dtDst.Columns.Add("OrgState", System.Type.GetType("System.String"))
                dtDst.Columns.Add("OrgZipcode", System.Type.GetType("System.String"))
                dtDst.Columns.Add("OrgCountry", System.Type.GetType("System.String"))
                dtDst.Columns.Add("wLtlCost", System.Type.GetType("System.Double"))
                dtDst.Columns.Add("wLtlLimit", System.Type.GetType("System.Double"))
                dtDst.Columns.Add("wEaUnit", System.Type.GetType("System.String"))
                dtDst.Columns.Add("wEaWgt", System.Type.GetType("System.Double"))
                dtDst.AcceptChanges()

                'Fill Product datatable
                For Each ci As CartItem In wCartItems
                    drP = dtPrd.NewRow
                    drP("DistributorID") = ci.DistributorID
                    drP("ProductID") = ci.ProductID
                    drP("Weight") = ci.Weight
                    drP("Quantity") = ci.Quantity
                    drP("Price") = ci.Price
                    drP("TotWeight") = ci.Weight * ci.Quantity
                    drP("TotPrice") = ci.Price * ci.Quantity
                    drP("wShipFree") = ci.FreeShipping
                    dtPrd.Rows.Add(drP)
                    dtPrd.AcceptChanges()
                Next

                'Create Product dataview to sort by distributor
                Dim dvPrd As DataView = New DataView(dtPrd)
                dvPrd.Sort = "DistributorID"
                dtPrd = dvPrd.ToTable

                'Fill Distributor datatable
                Dim TmpDst As Integer = 0
                For Each drP In dtPrd.Rows
                    If wGetInt(drP("DistributorID")) <> wGetInt(TmpDst) Then
                        drD = dtDst.NewRow
                        drD("DistributorID") = drP("DistributorID")
                        dtDst.Rows.Add(drD)
                        dtDst.AcceptChanges()

                        TmpDst = wGetInt(drP("DistributorID"))
                    End If
                Next

                'Update Product datatable with ltl tag for each product
                Dim IncStr As String = "0"

                For Each drP In dtPrd.Rows
                    IncStr += "," & drP("ProductID").ToString
                Next

                Dim Qry As String = String.Empty
                Qry = " SELECT * FROM ProductVariant "
                Qry += " WHERE ProductID IN (" & IncStr & ") "

                Using con As New SqlConnection(DB.GetDBConn())
                    con.Open()
                    Using rs As IDataReader = DB.GetRS(Qry, con)
                        Do While rs.Read()
                            For Each drP In dtPrd.Rows
                                If wGetInt(drP("ProductID")) = wGetInt(rs("ProductID")) Then
                                    drP("wIsLtl") = rs("wIsLtl").ToString
                                    drP("wUnit") = rs("wUnit").ToString
                                    drP("wShipSep") = 1
                                    Exit For
                                End If
                            Next
                        Loop
                    End Using
                End Using

                'Update Distributor datatable with distributor details
                IncStr = "0"

                For Each drD In dtDst.Rows
                    IncStr += "," & drD("DistributorID").ToString
                Next

                Qry = String.Empty
                Qry = " SELECT * FROM Distributor "
                Qry += " WHERE DistributorID IN (" & IncStr & ") "

                Using con As New SqlConnection(DB.GetDBConn())
                    con.Open()
                    Using rs As IDataReader = DB.GetRS(Qry, con)
                        Do While rs.Read()
                            For Each drD In dtDst.Rows
                                If wGetInt(drD("DistributorID")) = wGetInt(rs("DistributorID")) Then
                                    drD("Name") = rs("Name").ToString
                                    drD("wLtlCost") = rs("wLtlCost").ToString
                                    drD("wLtlLimit") = rs("wLtlLimit").ToString
                                    drD("wEaUnit") = rs("wEaUnit").ToString
                                    drD("wEaWgt") = rs("wEaWgt").ToString
                                    Exit For
                                End If
                            Next
                        Loop
                    End Using
                End Using

                'Determine address for each distributor
                Dim DstZip As String = wCustomer.PrimaryShippingAddress.Zip.Trim()

                'BONGO Check for international - if so use CT zipcode
                If ((wCustomer.PrimaryShippingAddress.CountryID <> 1) Or (wCustomer.PrimaryShippingAddress.CountryID = 1 And StateList.Contains(wCustomer.PrimaryShippingAddress.StateID))) Then
                    DstZip = "06607"
                End If

                Dim OrgZip As String = String.Empty

                For Each drD In dtDst.Rows
                    If DstZip.Length > 0 Then
                        Qry = String.Empty
                        Qry = " SELECT TOP 1 "
                        Qry += " f.Address, "
                        Qry += " f.City, "
                        Qry += " f.State, "
                        Qry += " f.Zipcode "
                        Qry += " FROM wFacility f with (NOLOCK) "
                        Qry += " INNER JOIN wFacilityZipMatrix fzm ON f.FacilityID = fzm.FacilityID "
                        Qry += " INNER JOIN Distributor d ON f.DistributorID = d.DistributorID "
                        Qry += " WHERE f.DistributorID = " & drD("DistributorID").ToString & " "
                        Qry += " AND d.Published = 1 "
                        Qry += " AND d.Deleted = 0 "
                        Qry += " AND " & Left(DstZip, 3) & " BETWEEN fzm.CodeStart AND fzm.CodeEnd "

                        Using con As New SqlConnection(DB.GetDBConn())
                            con.Open()
                            Using rs As IDataReader = DB.GetRS(Qry, con)
                                Do While rs.Read()
                                    drD("OrgCity") = rs("City")
                                    drD("OrgState") = rs("State")
                                    drD("OrgZipcode") = rs("Zipcode")
                                    drD("OrgCountry") = "US"
                                Loop
                            End Using
                        End Using
                    Else
                        drD("OrgCity") = "Jeffersonville"
                        drD("OrgState") = "PA"
                        drD("OrgZipcode") = "19403"
                        drD("OrgCountry") = "US"
                    End If
                Next

                'Initial check of products for shipments going ltl
                For Each drD In dtDst.Rows
                    'Changed to create query filter before the actual compute statement
                    Dim QryCond As String = "DistributorID=" & drD("DistributorID").ToString & " AND wShipFree=0"

                    If wGetInt(dtPrd.Compute("Sum(wIsLtl)", QryCond)) > 0 Then
                        drD("ShipIsLtl") = 1
                        drD("ShipCost") = drD("wLtlCost")
                    ElseIf wGetInt(dtPrd.Compute("SUM(TotWeight)", QryCond)) > wGetInt(drD("wLtlLimit")) Then
                        drD("ShipIsLtl") = 1
                        drD("ShipCost") = drD("wLtlCost")
                    Else
                        drD("ShipIsLtl") = 0
                        drD("ShipCost") = 0
                    End If

                    'If wGetInt(dtPrd.Compute("Sum(wIsLtl)", "DistributorID = " & drD("DistributorID").ToString) & " AND wShipFree=0") > 0 Then
                    '    drD("ShipIsLtl") = 1
                    '    drD("ShipCost") = drD("wLtlCost")
                    'ElseIf wGetInt(dtPrd.Compute("SUM(TotWeight)", "DistributorID = " & drD("DistributorID").ToString & " AND wShipFree=0")) > wGetInt(drD("wLtlLimit")) Then
                    '    drD("ShipIsLtl") = 1
                    '    drD("ShipCost") = drD("wLtlCost")
                    'Else
                    '    drD("ShipIsLtl") = 0
                    '    drD("ShipCost") = 0
                    'End If

                    drD("ShipWeight") = dtPrd.Compute("SUM(TotWeight)", "DistributorID = " & drD("DistributorID").ToString)
                    drD("ShipValue") = dtPrd.Compute("SUM(TotPrice)", "DistributorID = " & drD("DistributorID").ToString)
                Next

                For Each drD In dtDst.Rows
                    If wGetInt(drD("ShipIsLtl")) = 0 And drD("wEaUnit").ToString <> "NONE" And Len(drD("wEaUnit").ToString) > 0 Then
                        For Each drP In dtPrd.Rows
                            If drD("wEaUnit").ToString = "ALL" And CDbl(drP("Weight")) <= CDbl(drD("wEaWgt")) Then
                                drP("wShipSep") = 0
                            End If
                            If CDbl(drP("Weight")) <= CDbl(drD("wEaWgt")) And Microsoft.VisualBasic.InStr(drD("wEaUnit").ToString.Trim, drP("wUnit").ToString.Trim, CompareMethod.Text) > 0 And wGetInt(drP("DistributorID")) = wGetInt(drD("DistributorID")) Then
                                drP("wShipSep") = 0
                            End If
                        Next
                    End If
                Next

                'Start shipping calculation here
                Dim Tmp_Methods As ShippingMethods = New ShippingMethods

                For Each drD In dtDst.Rows
                    If wGetInt(drD("ShipIsLtl")) = 0 Then
                        Dim realTimeShipping As New RTShipping()

                        Dim shipments As New Shipments()
                        Dim shipment As New Packages()

                        shipments = New Shipments()

                        Dim PackageID As Integer = 1

                        For Each drP In dtPrd.Rows
                            If wGetInt(drP("DistributorID")) = wGetInt(drD("DistributorID")) And wGetInt(drP("wShipSep")) = 1 And wGetInt(drP("wShipFree")) = 0 Then
                                shipment = New Packages()

                                'If wCustomer.PrimaryShippingAddress.Country <> "US" Then
                                If ((wCustomer.PrimaryShippingAddress.CountryID <> 1) Or (wCustomer.PrimaryShippingAddress.CountryID = 1 And StateList.Contains(wCustomer.PrimaryShippingAddress.StateID))) Then
                                    shipment.DestinationAddress1 = "315 Seaview Ave"
                                    shipment.DestinationCity = "Bridgeport"
                                    shipment.DestinationStateProvince = "CT"
                                    shipment.DestinationZipPostalCode = "06607"
                                    shipment.DestinationCountryCode = "US"
                                    shipment.DestinationResidenceType = ResidenceTypes.Commercial
                                Else
                                    shipment.DestinationAddress1 = wCustomer.PrimaryShippingAddress.Address1
                                    shipment.DestinationCity = wCustomer.PrimaryShippingAddress.City
                                    shipment.DestinationStateProvince = wCustomer.PrimaryShippingAddress.State
                                    shipment.DestinationZipPostalCode = wCustomer.PrimaryShippingAddress.Zip
                                    shipment.DestinationCountryCode = "US"
                                    shipment.DestinationResidenceType = wCustomer.PrimaryShippingAddress.ResidenceType
                                End If

                                shipment.PickupType = "UPSDailyPickup"

                                Dim p As New Package()

                                p.PackageId = PackageID
                                p.Weight = wGetDec(drP("Weight"))
                                p.Quantity = wGetInt(drP("Quantity"))
                                p.IsShipSeparately = True

                                shipment.AddPackage(p)
                                shipments.AddPackages(shipment)

                                shipment = Nothing
                                p = Nothing

                                PackageID += 1
                            End If
                        Next

                        'This is the version that creates multiple boxes based on weight>70lbs
                        If wGetInt(dtPrd.Compute("COUNT(ProductID)", "wShipSep=0 AND wShipFree=0 AND DistributorID = " & drD("DistributorID").ToString)) > 0 Then
                            Dim TmpWgt As Decimal = 0D

                            For Each drP In dtPrd.Rows
                                If wGetInt(drP("wShipSep")) = 0 Then
                                    TmpWgt += wGetDec(drP("Weight")) * wGetDec(drP("Quantity"))
                                End If
                            Next

                            Dim TmpPkgCnt As Integer = wGetInt(Math.Ceiling(TmpWgt / 70))
                            Dim TmpPkgWgt As Decimal = TmpWgt / TmpPkgCnt

                            For i As Integer = 1 To TmpPkgCnt
                                shipment = New Packages()

                                If ((wCustomer.PrimaryShippingAddress.CountryID <> 1) Or (wCustomer.PrimaryShippingAddress.CountryID = 1 And StateList.Contains(wCustomer.PrimaryShippingAddress.StateID))) Then
                                    'If wCustomer.PrimaryShippingAddress.Country <> "US" Then
                                    shipment.DestinationAddress1 = "315 Seaview Ave"
                                    shipment.DestinationCity = "Bridgeport"
                                    shipment.DestinationStateProvince = "CT"
                                    shipment.DestinationZipPostalCode = "06607"
                                    shipment.DestinationCountryCode = "US"
                                    shipment.DestinationResidenceType = ResidenceTypes.Commercial
                                Else
                                    shipment.DestinationAddress1 = wCustomer.PrimaryShippingAddress.Address1
                                    shipment.DestinationCity = wCustomer.PrimaryShippingAddress.City
                                    shipment.DestinationStateProvince = wCustomer.PrimaryShippingAddress.State
                                    shipment.DestinationZipPostalCode = wCustomer.PrimaryShippingAddress.Zip
                                    shipment.DestinationCountryCode = "US"
                                    shipment.DestinationResidenceType = wCustomer.PrimaryShippingAddress.ResidenceType
                                End If

                                shipment.PickupType = "UPSDailyPickup"

                                Dim p As New Package()

                                p.PackageId = PackageID
                                p.IsShipSeparately = True


                                p.Weight = wGetDec(TmpPkgWgt)
                                p.Quantity = 1

                                shipment.AddPackage(p)
                                shipments.AddPackages(shipment)

                                shipment = Nothing
                                p = Nothing

                                PackageID += 1
                            Next
                        End If

                        realTimeShipping.ShipmentValue = wGetDec(drD("ShipValue"))
                        realTimeShipping.ShipmentWeight = wGetDec(drD("ShipWeight"))
                        realTimeShipping.OriginCity = drD("OrgCity").ToString
                        realTimeShipping.OriginStateProvince = drD("OrgState").ToString
                        realTimeShipping.OriginZipPostalCode = drD("OrgZipcode").ToString
                        realTimeShipping.OriginCountry = "US"

                        Dim carriers As String = String.Empty
                        For Each rtps As Packages In shipments
                            If rtps.DestinationCountryCode.Equals("US", StringComparison.InvariantCultureIgnoreCase) Then
                                carriers = AppLogic.AppConfig("RTshipping.DomesticCarriers")
                            Else
                                carriers = AppLogic.AppConfig("RTshipping.InternationalCarriers")
                            End If
                        Next rtps
                        If carriers.Length = 0 Then
                            carriers = AppLogic.AppConfig("RTShipping.ActiveCarrier")
                        End If

                        Dim format As RTShipping.ResultType = RTShipping.ResultType.CollectionList

                        Dim VATOn As Boolean = False
                        Dim ShippingHandlingExtraFee As Decimal = 0D
                        Dim ShippingTaxRate As Decimal = 0D
                        Dim MarkupPercent As Decimal = 0D

                        Dim RTShipRequest As String = String.Empty
                        Dim RTShipResponse As String = String.Empty

                        Dim s_methods As ShippingMethods = CType(realTimeShipping.GetRates(shipments, carriers, format, "ShippingMethod", "ShippingMethod", ShippingTaxRate, RTShipRequest, RTShipResponse, ShippingHandlingExtraFee, MarkupPercent, realTimeShipping.ShipmentValue, Nothing), ShippingMethods)

                        Try
                            DB.ExecuteSQL("update customer set RTShipRequest=" & DB.SQuote(RTShipRequest) & ", RTShipResponse=" & DB.SQuote(RTShipResponse) & " where customerid=" & wCustomer.CustomerID.ToString())
                        Catch ex As Exception
                        End Try

                        For Each sm As ShipMethod In s_methods
                            Tmp_Methods.AddMethod(sm)
                        Next

                        realTimeShipping = Nothing
                    Else
                        Dim Tmp_Method As ShipMethod = New ShipMethod
                        Tmp_Method.ShippingMethodID = 7
                        Tmp_Method.ServiceName = "LTL"
                        Tmp_Method.ServiceRate = wGetDec(drD("wLtlCost"))
                        Tmp_Methods.AddMethod(Tmp_Method)
                    End If
                Next

                If Tmp_Methods.Count > 0 Then
                    Dim Fnl_Ltl As Integer = 0
                    Dim Fnl_Ups As Integer = 0
                    Dim Fnl_Rate As Decimal = 0D

                    Dim TotalValue As Decimal = 0D

                    If dtDst.Rows.Count > 0 Then
                        TotalValue = wGetDec(dtDst.Compute("Sum(ShipValue)", "1=1"))
                    End If

                    Dim ShipDiscount As Decimal = 1D

                    '10/01/2011 - implemented discount of 12% across board

                    '01/10/2012 - discount table
                    'less than $50 - discount %20
                    '50.01 to 100 - discount %18
                    '100.01 to 150 - discount %16
                    '150.01 to 300 - discount %14
                    '300.01 to 500 - discount %12

                    '03/08/2012 - discount table
                    'less than $50 - discount %20
                    '50.01 to 100 - discount %18
                    '100.01 to 150 - discount %16
                    '150.01 to 300 - discount %16
                    '300.01 to 500 - discount %14

                    '04/16/2012 - Removed discount due to issue w/ UPS returning Published rates vs Counter Rates
                    '04/19/2012 - Added back in was an issue with Lagasse invoicing not our code

                    '07/06/2012 - discount table
                    'less than $50 - discount %26
                    '50.01 to 100 - discount %20
                    '100.01 to 150 - discount %18
                    '150.01 to 300 - discount %16
                    '300.01 to 500 - discount %14

                    If TotalValue > 0 And TotalValue <= 50 Then
                        ShipDiscount = 0.74D
                    ElseIf TotalValue > 50 And TotalValue <= 100 Then
                        ShipDiscount = 0.8D
                    ElseIf TotalValue > 100 And TotalValue <= 150 Then
                        ShipDiscount = 0.82D
                    ElseIf TotalValue > 150 And TotalValue <= 300 Then
                        ShipDiscount = 0.84D
                    ElseIf TotalValue > 300 And TotalValue <= 500 Then
                        ShipDiscount = 0.86D
                    End If

                    For Each Tmp_Method As ShipMethod In Tmp_Methods
                        If Tmp_Method.ServiceName = "UPS Ground" Then
                            Fnl_Ups = 1
                            Fnl_Rate += (Tmp_Method.ServiceRate * wGetDec(ShipDiscount))
                        End If
                        If Tmp_Method.ServiceName = "LTL" Then
                            Fnl_Ltl = 1
                            Fnl_Rate += Tmp_Method.ServiceRate
                        End If
                    Next

                    Dim Fnl_Method As ShipMethod = New ShipMethod

                    If Fnl_Ups > 0 And Fnl_Ltl > 0 Then
                        Fnl_Method.ServiceName = "UPS Ground / LTL"
                        Fnl_Method.ShippingMethodID = 8
                    ElseIf Fnl_Ups = 0 And Fnl_Ltl > 0 Then
                        Fnl_Method.ServiceName = "LTL"
                        Fnl_Method.ShippingMethodID = 7
                    Else
                        Fnl_Method.ServiceName = "UPS Ground"
                    End If

                    Dim FixedCost As Decimal = 0D

                    'Prior to 09192011 - FixedCost
                    'If TotalValue > 0 And TotalValue <= 80 Then
                    '    FixedCost = 1.5D
                    'ElseIf TotalValue > 80 And TotalValue < 1800 Then
                    '    FixedCost = 2.5D
                    'Else
                    '    FixedCost = 0D
                    'End If

                    '09192011 - FixedCost
                    If TotalValue > 300 And TotalValue < 1200 Then
                        FixedCost = 2.5D
                    End If

                    Fnl_Method.ServiceRate = Math.Round(Fnl_Rate + FixedCost, 2)
                    Fnl_Methods.AddMethod(Fnl_Method)
                End If
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wGetRates", "app")
        End Try

        Return Fnl_Methods
    End Function

    Public Shared Function wDetermineLevelPrice(ByVal VariantID As Integer, ByVal CustomerLevelID As Integer, ByVal Price As Decimal, ByVal SalePrice As Decimal, ByVal ExtendedPrice As Decimal) As Decimal
        Dim FinalPrice As Decimal = Decimal.Zero

        Try
            Dim ExtendedPriceFound As Boolean = False

            If SalePrice <> Decimal.Zero And SalePrice < Price Then
                FinalPrice = SalePrice
            Else
                FinalPrice = Price
            End If

            If CustomerLevelID > 0 Then
                If ExtendedPrice <> Decimal.Zero Then
                    FinalPrice = ExtendedPrice
                    ExtendedPriceFound = True
                End If

                Using oCn As New SqlConnection(DB.GetDBConn())
                    oCn.Open()
                    Using rs As IDataReader = DB.GetRS("SELECT * FROM CustomerLevel WITH (NOLOCK) WHERE CustomerLevelID=" & CustomerLevelID.ToString() & " ", oCn)
                        If rs.Read() Then
                            Dim DiscountPercent As Decimal = DB.RSFieldDecimal(rs, "LevelDiscountPercent")
                            Dim LevelDiscountsApplyToExtendedPrices As Boolean = DB.RSFieldBool(rs, "LevelDiscountsApplyToExtendedPrices")
                            rs.Close()
                            If DiscountPercent <> Decimal.Zero Then
                                If (Not ExtendedPriceFound) OrElse (ExtendedPriceFound AndAlso LevelDiscountsApplyToExtendedPrices) Then
                                    FinalPrice = FinalPrice * wGetDec(1D - (DiscountPercent / 100D))
                                End If
                            End If
                        End If
                    End Using
                End Using
            End If

            FinalPrice = Decimal.Round(FinalPrice, 4, MidpointRounding.AwayFromZero)
        Catch ex As Exception
            wPostError(ex.ToString, "wDetermineLevelPrice", "app")
        End Try

        Return FinalPrice
    End Function


    'Pricing Programs
    Public Shared Sub wSetCseCookie(ByVal prgid As String)
        'Program Options
        'dp1pp - DEFAULT Pricing
        'cs7pp - CSE Pricing

        Try
            If prgid.Length > 0 Then
                Select Case prgid
                    Case "dp1pp" 'remove cookie
                        AppLogic.SetCookie("PriceProgram", String.Empty, New TimeSpan(-1, 0, 0, 0))
                    Case "cs7pp" 'set cookie
                        AppLogic.SetCookie("PriceProgram", "cs7pp", New TimeSpan(30, 0, 0, 0)) 'dy,hr,mn,sc
                End Select
            End If
        Catch ex As Exception
            wPostError(ex.ToString, "wSetCseCookie", "app")
        End Try
    End Sub

    Public Shared Sub wTrackPrgRef(ByVal Url As String)
        Try
            Dim Sql As String = " INSERT INTO wPrgRef (Url) VALUES (@Url) "

            Dim oCn As New SqlConnection(DB.GetDBConn())
            oCn.Open()

            Dim oCm As SqlCommand = New SqlCommand(Sql, oCn)

            Dim pUrl = New SqlParameter("@Url", SqlDbType.VarChar)
            pUrl.Value = Url
            oCm.Parameters.Add(pUrl)

            oCm.ExecuteNonQuery()

            oCm.Dispose()
            oCm = Nothing

            oCn.Close()
            oCn = Nothing
        Catch ex As SqlException
            wPostError(ex.ToString, "wTrackPrgRef", "sql")
        End Try
    End Sub

    'PUT THIS IN SkinBase.vb due to reload function
    'Public Shared Sub wCheckCseCookie(ByVal Cust As Customer)
    '    Dim Result As String = String.Empty

    '    'Program Options
    '    'dp1pp - DEFAULT Pricing
    '    'cs7pp - CSE Pricing

    '    If Not HttpContext.Current.Request.Cookies("PriceProgram") Is Nothing Then
    '        If CommonLogic.CookieCanBeDangerousContent("PriceProgram", False) = "cs7pp" Then
    '            If Not Cust.HasCustomerRecord Then
    '                Cust.RequireCustomerRecord()
    '            End If
    '            If Cust.HasCustomerRecord And Cust.CustomerLevelID = 0 Then
    '                Dim sp1 As SqlParameter = DB.CreateSQLParameter("@CustomerLevelID", SqlDbType.Int, 4, 115, ParameterDirection.Input)
    '                Dim spa() As SqlParameter = {sp1}
    '                Cust.UpdateCustomer(spa)
    '            End If
    '        End If
    '    Else
    '        If Cust.HasCustomerRecord And Cust.CustomerLevelID = 115 Then
    '            Dim sp1 As SqlParameter = DB.CreateSQLParameter("@CustomerLevelID", SqlDbType.Int, 4, 0, ParameterDirection.Input)
    '            Dim spa() As SqlParameter = {sp1}
    '            Cust.UpdateCustomer(spa)
    '        End If
    '    End If
    'End Sub

    Public Function wDebugCseCookie(ByVal Url As String) As String
        Dim Result As String = String.Empty

        Result += "Cookie=" & CommonLogic.CookieCanBeDangerousContent("PriceProgram", False) & "<br/>"
        Result += "CustomerID= " & ThisCustomer.CustomerID.ToString & "<br/>"
        Result += "LevelID= " & ThisCustomer.CustomerLevelID.ToString

        Return Result
    End Function

    'Misc Functions
    Private Function wGetDt(ByVal Qry As String, Optional ByVal cp As Integer = 0, Optional ByVal ip As Integer = 0) As DataTable
        Dim Result As DataTable = New DataTable

        Using oCn As New SqlConnection(DB.GetDBConn())
            oCn.Open()

            Dim oCm As SqlCommand = New SqlCommand(Qry, oCn)
            Dim oAd As New SqlDataAdapter(oCm)

            If cp > 0 Then
                oAd.Fill(ip * (cp - 1), ip, Result)
            Else
                oAd.Fill(Result)
            End If

            oCn.Close()

            oAd.Dispose()
            oCm.Dispose()
            oCn.Dispose()
        End Using

        Return Result
    End Function

    Private Function wStripBadChr(ByVal Html As String) As String
        Dim Result As String = wGetStr(Html)

        Result = Replace(Result, "&", "&amp;")
        Result = Replace(Result, """", "&quot;")

        Return Result
    End Function

    Private Shared Function wGetInt(ByVal val As Object) As Integer
        Dim Result As Integer = 0

        If Not (val Is Nothing) Then
            If IsNumeric(val) Then
                Result = CInt(val)
            End If
        End If

        Return Result
    End Function

    Private Shared Function wGetDec(ByVal val As Object) As Decimal
        Dim Result As Decimal = Decimal.Zero

        If Not (val Is Nothing) Then
            If IsNumeric(val) Then
                Result = CDec(val)
            End If
        End If

        Return Result
    End Function

    Private Shared Function wGetStr(ByVal val As Object) As String
        Dim Result As String = String.Empty

        If Not (val Is Nothing) Then
            Result = CStr(val)
        End If

        Return Result
    End Function

    Private Shared Sub wPostError(ByVal err As String, ByVal loc As String, ByVal type As String)

    End Sub

    Public Function wGetEmailForm() As String
        Dim Result As String = String.Empty

        Try
            Result += "</form>"
            Result += "<div class=""MiscEmailBox"">"
            'Result += "    <img src=""/App_Templates/Skin_1/Images/Banner/bnr_right_email_tmp2.gif"" width=""185"" height=""55"" alt=""Clean it offers"" />"
            Result += "        <script type=""text/javascript"" language=""javascript"" src=""/App_Templates/Skin_1/Scripts/wCookie.js""></script>"
            Result += "        <script type=""text/javascript"" language=""javascript"">"
            Result += "	    <!--"
            Result += "            function validate() {"
            Result += "                var email = document.listrakform.email.value;"
            Result += "                if (email.length == 0) {"
            Result += "                    alert(""Please enter your email address."");"
            Result += "                    return false;"
            Result += "                }"
            Result += "                var atpos = email.indexOf(""@"");"
            Result += "                var dotpos = email.lastIndexOf(""."");"
            Result += "                if (atpos < 1 || dotpos < atpos + 2 || dotpos + 2 >= email.length) {"
            Result += "                    alert(""You have entered an invalid email address"");"
            Result += "                    return false;"
            Result += "                }"
            Result += "                createCookie(""EmailTmp"", email, 365);"
            Result += "            }"
            Result += "	    //-->"
            Result += "    </script>"
            Result += "    <form name=""listrakform"" method=""post"" action=""http://enews.cleanitsupply.com/q/GQiIPTb2S8Oaqt2Z27coPBGzhSqmK95VUB"" onsubmit=""return validate();"">"
            Result += "    <input type=""hidden"" name=""crvs"" value=""rrbFpPCQIXb5gi4h9AIm8lSGZUlovV2ebXJRVy1adK6tHH6kTl29p3Due8TtoUNM-oUgoXQGe_umzqe4iM8ok9zfDLdOwKJ-jQsaMsHPNsaGH_pBWiaqG4kwo8tsO9S_CgbIP1T9otHjhNtrpXIt61gYRfMfVA8G14C5Gyww9KO1Wdgt5zRbCVqKAFouges_8dmL5sucBJ1pjCN8S_-I5Q""/>"
            Result += "        &#160;<input name=""email"" type=""text"" size=""13"" style=""margin:55px 0px 8px 5px; border:1px solid #000000; width:130px; height:25px;"" value=""Your E-mail"" onFocus=""if (this.value == 'Your E-mail') { this.value=''; }"" onBlur=""if (this.value == '') { this.value='Your E-mail'; }"" />"
            Result += "        <input type=""submit"" name=""submit"" value="""" class=""MiscEmailGo"" />"
            Result += "    </form>  "
            Result += "</div>"
            Result += "<form>"
        Catch ex As Exception
            wPostError(ex.ToString, "wGetEmailForm", "app")
        End Try

        Return Result
    End Function

    'SWANKADD
    ' Swank Additions for rel="next" rel="prev" Header Tags on Paginated Category Pages

    Public Function GetEntityID() As String
        Dim currentPage As String = CommonLogic.GetThisPageName(False).Trim().ToLower()

        Try
            Dim StartIndex As Integer = currentPage.IndexOf("-") + 1
            Dim subCurrentPage As String = currentPage.Substring(StartIndex)
            Dim EndIndex As Integer = subCurrentPage.IndexOf("-")

            If StartIndex > 0 And EndIndex > 0 Then
                Try
                    Return Convert.ToInt32(currentPage.Substring(StartIndex, EndIndex)).ToString()
                Catch
                    Return "0"
                End Try
            Else
                Return "0"
            End If
        Catch ex As Exception
            Return "0"
        End Try

    End Function

    Public Function GetEntityName() As String
        Dim currentPage As String = CommonLogic.GetThisPageName(False).Trim().ToLower()

        If currentPage.StartsWith("search.aspx") Then
            Return "search"
        End If

        Select Case LCase(currentPage.Substring(0, 2))
            Case "c-"
                Return "category"
            Case "d-"
                Return "distributor"
            Case "m-"
                Return "manufacturer"
            Case "v-"
                Return "vector"
            Case "s-"
                Return "section"
            Case "g-"
                Return "genre"
            Case Else
                Return "other"
        End Select

    End Function

    Public Function GetNextPageNumber(ByVal sEntityID As String, ByVal sEntityName As String, ByVal sCurrentPage As String, ByVal sNumProductsPerPage As String) As String
        Dim IV As InputValidator = New InputValidator("GetNextPageNumber")
        Dim EntityID As Integer = IV.ValidateInt("EntityID", sEntityID)
        Dim EntityName As String = IV.ValidateString("EntityName", sEntityName)
        Dim CurrentPage As Integer = IV.ValidateInt("CurrentPage", sCurrentPage)
        Dim NumProductsPerPage As Integer = IV.ValidateInt("NumProductsPerPage", sNumProductsPerPage)

        ' Only Look in DB if a valid entity (cat, distrib, man, sec)
        If EntityName = "category" Or EntityName = "distributor" Or EntityName = "manufacturer" Or EntityName = "section" Then

            Dim GetNumProductsSQL As String = String.Empty
            GetNumProductsSQL += "SELECT COUNT(*) As N "
            GetNumProductsSQL += "FROM Product p "
            GetNumProductsSQL += "INNER JOIN ProductVariant pv ON p.ProductID = pv.ProductID "
            GetNumProductsSQL += "INNER JOIN Product{EntityName} pe ON p.ProductID = pe.ProductID "
            GetNumProductsSQL += "WHERE p.Published = 1 AND p.Deleted = 0 AND pv.Published = 1 AND pv.Deleted = 0 AND p.ShowBuyButton = 1 AND pe.{EntityName}ID = {EntityID} "
            GetNumProductsSQL += "GROUP BY pe.{EntityName}ID"
            GetNumProductsSQL = GetNumProductsSQL.Replace("{EntityName}", EntityName).Replace("{EntityID}", EntityID.ToString())

            Try
                Dim NumProducts As Integer = DB.GetSqlN(GetNumProductsSQL)
                Dim NumPages As Integer = wGetInt(Math.Ceiling(NumProducts / NumProductsPerPage))

                If NumPages = 0 Then
                    NumPages = 1
                End If

                If NumPages > CurrentPage Then
                    Return (CurrentPage + 1).ToString()
                Else
                    Return CurrentPage.ToString()
                End If

            Catch ex As Exception
                Return CurrentPage.ToString()
            End Try

        Else ' Otherwise Revert to Current Page as Default
            Return CurrentPage.ToString()
        End If

    End Function

    ' End Swank Additions
    'ENDSWANKADD

End Class